Attribute VB_Name = "modP3"
Option Explicit

Public objUtil As clsUtil
Public objP3IO As clsP3IO
Public objFluid As clsFluid
Public objPrs As clsPrs
Public objOil As clsOil
Public objGas As clsGas
Public objWat As clsWater
Public objPrj As clsProject
Public objRock As clsRock

Public rsFluid As ADODB.Recordset
Public rsPressure As ADODB.Recordset
Public rsOil As ADODB.Recordset
Public rsGas As ADODB.Recordset
Public rsWater As ADODB.Recordset
Public rsRock As ADODB.Recordset

Public dbOPEN As Boolean
Public prjOPEN As Boolean
Public UserClick As Boolean
Public WarnUser As Boolean

Public curPrjID As Long
Public curPrjName As String

Public Enum formflags
   ffNewRecord = 1
   ffOldRecord = 2
End Enum

Public recType As formflags

Public Sub fxgSelect(fxgIN As MSHFlexGrid, inCols As Integer, rowPrev As Integer, _
                     idIN As Long)
  
  Dim rowCur As Integer
  Dim iCol As Integer
'
'---Check for empty recordset
'
  If rowPrev > 0 Then
'
'---Highlight current row and return key value.  First, de-highlight previous row
'
    rowCur = fxgIN.Row
  
    fxgIN.Row = rowPrev
    For iCol = 1 To inCols
      fxgIN.Col = iCol
      fxgIN.CellBackColor = &HFFFFFF    'White
    Next iCol
'
'---Highlight current row
'
    rowPrev = rowCur
    fxgIN.Row = rowCur
    For iCol = 1 To inCols
      fxgIN.Col = iCol
      fxgIN.CellBackColor = &HCED192     'Highlight color
    Next iCol
'
'---Assume last column contains row key value
'
    fxgIN.Col = inCols + 1
    idIN = fxgIN.Text
  End If

End Sub

Public Function loadCombo(cbxIN As ComboBox, rsCBX As ADODB.Recordset, _
                          defaultIN As Long) As Long
   
  Dim saveIndex As Integer
  
  saveIndex = 0
  
  cbxIN.Clear
  Do While Not rsCBX.EOF
    cbxIN.AddItem rsCBX!ItemName
    cbxIN.ItemData(cbxIN.NewIndex) = rsCBX!ItemID
    If defaultIN = rsCBX!ItemID Then
      saveIndex = cbxIN.NewIndex
    End If
    rsCBX.MoveNext
  Loop
  
  cbxIN.ListIndex = saveIndex
  loadCombo = cbxIN.ItemData(cbxIN.ListIndex)
  
End Function

Public Sub SelectAll(txbIN As TextBox)
  txbIN.SelStart = 0
  txbIN.SelLength = Len(txbIN)
End Sub

Public Sub ErrMSGx(emsg As String, etitle As String)
  MsgBox emsg, vbCritical + vbOKOnly, etitle
End Sub

Public Sub InfoMSG(emsg As String, etitle As String)
  MsgBox emsg, vbInformation + vbOKOnly, etitle
End Sub

Public Function Confirm(msgIn As String, titleIN As String) As Boolean
  
  Dim iReturn As Integer
  
  Confirm = (MsgBox(msgIn, vbYesNo + vbCritical, titleIN) = vbYes)
End Function

Public Sub NewProject(prjIN As Long)
  Call objP3IO.SaveFluid(prjIN)
  Call objP3IO.SavePressure(prjIN)
  Call objP3IO.SaveOil(prjIN)
  Call objP3IO.SaveGas(prjIN)
  Call objP3IO.SaveWater(prjIN)
  Call objP3IO.SaveRock(prjIN)
End Sub

Public Sub LoadProject(prjIN As Long)
  Dim ii As Integer
  
  UserClick = False
  Set rsFluid = objP3IO.LoadPrjTbl("tblFluidSpec", curPrjID)
  Set rsPressure = objP3IO.LoadPrjTbl("tblPressureSpec", curPrjID)
  Set rsOil = objP3IO.LoadPrjTbl("tblOilGravity", curPrjID)
  Set rsGas = objP3IO.LoadPrjTbl("tblGasComp", curPrjID)
  Set rsWater = objP3IO.LoadPrjTbl("tblWater", curPrjID)
  Set rsRock = objP3IO.LoadPrjTbl("tblRock", curPrjID)
'
'---Load Fluid input data
'
  frmMain.cbxFPP(0) = rsFluid!PhaseOil
  frmMain.cbxFPP(1) = rsFluid!PhaseGas
  frmMain.cbxFPP(2) = rsFluid!PhaseWater
  
  frmMain.txtStdP = rsFluid!StdPressure
  frmMain.txtStdT = rsFluid!StdTemp
  frmMain.optStdTU(0) = (rsFluid!StdTempUnits = "F")
  frmMain.optStdTU(1) = (rsFluid!StdTempUnits = "C")
  
  frmMain.txtResT = rsFluid!RESTEMP
  frmMain.optResTU(0) = (rsFluid!ResTempUnits = "F")
  frmMain.optResTU(1) = (rsFluid!ResTempUnits = "C")
'
'---Load Pressure input data
'
  frmMain.optPRange(0) = (rsPressure!PrRange = "R")
  frmMain.optPRange(1) = (rsPressure!PrRange = "I")
  frmMain.txtMinP = rsPressure!MinPr
  frmMain.txtMinP.Enabled = frmMain.optPRange(0).Value
  
  frmMain.txtInitP = rsPressure!InitPr
  frmMain.txtInitP.Enabled = frmMain.optPRange(0).Value
  
  frmMain.txtMaxP = rsPressure!MaxPr
  frmMain.txtMaxP.Enabled = frmMain.optPRange(0).Value
  
  For ii = 1 To 18
    frmMain.txtP(ii) = rsPressure("p" & ii)
    frmMain.txtP(ii).Enabled = frmMain.optPRange(1).Value
  Next ii
'
'---Load Oil gravity inputs
'
  frmMain.txtAPI = rsOil!API
  frmMain.txtGrav = rsOil!SpecGrav
  frmMain.txtSepGas = rsOil!SepGasGrav
  frmMain.txtSepP = rsOil!SepP
  frmMain.txtSepT = rsOil!SepT
  frmMain.optSepTU(0) = (rsOil!SepTUnits = "F")
  frmMain.optSepTU(1) = (rsOil!SepTUnits = "C")
  frmMain.txtRSI = rsOil!InitGO
  frmMain.txtBPP = rsOil!BPP
'
'---Load Gas composition data
'
  frmMain.optGasEntry(0) = (rsGas!GasEntry = "G")
  frmMain.optGasEntry(1) = (rsGas!GasEntry = "C")
  
  frmMain.txtGasGrav = Format(rsGas!GasGrav, "0.0000")
  frmMain.txtGasGrav.Enabled = frmMain.optGasEntry(0).Value
  
  frmMain.txtMFN = Format(rsGas!MFnitrogen, "0.0000")
  frmMain.txtMFN.Enabled = frmMain.optGasEntry(0).Value
  
  frmMain.txtMFCO2 = Format(rsGas!mfCO2, "0.0000")
  frmMain.txtMFCO2.Enabled = frmMain.optGasEntry(0).Value
  
  frmMain.txtMFHS = Format(rsGas!mfH2S, "0.0000")
  frmMain.txtMFHS.Enabled = frmMain.optGasEntry(0).Value
  
  For ii = 1 To 15
    frmMain.txtGC(ii) = Format(rsGas("gc" & ii), "0.0000")
    frmMain.txtGC(ii).Enabled = frmMain.optGasEntry(1).Value
  Next ii
'
'---Load Water data
'
  frmMain.txtPPM = rsWater!PPMSalinity
  frmMain.txtPER = rsWater!PERSalinity
'
'---Load Rock data
'
  frmMain.optRock(0) = (rsRock!RockType = 0)
  frmMain.optRock(1) = (rsRock!RockType = 1)
  frmMain.optType(0) = (rsRock!DrainType = 0)
  frmMain.optType(1) = (rsRock!DrainType = 1)
  frmMain.optLith(0) = (rsRock!LithType = 0)
  frmMain.optLith(1) = (rsRock!LithType = 1)
  frmMain.optWet(0) = (rsRock!WetType = 0)
  frmMain.optWet(1) = (rsRock!WetType = 1)
  frmMain.optCorr(0) = (rsRock!CorrType = 0)
  frmMain.optCorr(1) = (rsRock!CorrType = 1)
  
  frmMain.txtSWC = Format(rsRock!SWC, "0.00")
  frmMain.txtSORW = Format(rsRock!SORW, "0.00")
  frmMain.txtSORG = Format(rsRock!SORG, "0.00")
  frmMain.txtSGCrit = Format(rsRock!SGCrit, "0.00")
  
  frmMain.txtK = rsRock!CoreyK
  frmMain.txtN = rsRock!CoreyN
  frmMain.txtHRPoro = rsRock!HRPoro
  frmMain.txtHRAir = rsRock!HRAir
  frmMain.txtHRKrg = rsRock!HRKrg
'
'---Initialize
'
  frmMain.txtProject.Visible = True
  frmMain.txtProject.Text = curPrjName
  
  frmMain.mnuEdit.Enabled = True
  frmMain.mnuClose.Enabled = True
  frmMain.mnuDelete.Enabled = False
  prjOPEN = True
  frmMain.sstMain.Tab = 0
  
  UserClick = True
  
End Sub

Public Sub dbUpdate(rsIN As ADODB.Recordset, fieldIN As String, valueIN As Variant)
  
  If UserClick And prjOPEN Then
    If valueIN = "" Then valueIN = 0
    rsIN(fieldIN) = valueIN
    Call objP3IO.SaveREC(rsIN)
  End If
End Sub

Public Sub P3Init()
  If objFluid.PhaseOil Then frmMain.cbxFPP(0).Value = 1
  If objFluid.PhaseGas Then frmMain.cbxFPP(1).Value = 1
  If objFluid.PhaseWater Then frmMain.cbxFPP(2).Value = 1
  
  frmMain.txtStdP = objFluid.StdP
  frmMain.txtStdT = objFluid.StdTf
  frmMain.optStdTU(0).Value = (objFluid.StdTU = "F")

  frmMain.txtResT = objFluid.ResTf
  frmMain.optResTU(0).Value = (objFluid.ResTU = "F")
  
  frmMain.optPRange(0) = (objPrs.PrRange = "R")
  frmMain.txtMaxP = objPrs.PrMax
  frmMain.txtInitP = objPrs.PrIni
  frmMain.txtMinP = objPrs.PrMin
  
  frmMain.txtAPI = Format(objOil.API, "0.0000")
  frmMain.txtGrav = Format(objOil.OilSG, "0.0000")
  frmMain.txtSepGas = objOil.SepGG
  frmMain.txtSepP = objOil.SepP
  frmMain.txtSepT = objOil.SepTf
  frmMain.optSepTU(0).Value = (objOil.SepTU = "F")
  frmMain.txtRSI = Format(objOil.RSI, "0.0")
  'frmMain.txtBPP = Format(objOil.Pbp, "0.0")
  
  frmMain.optGasEntry(0) = (objGas.GasEntry = "G")
  frmMain.txtGasGrav = objGas.GasGrav
  frmMain.txtPLUSmw = objGas.PLUSmw
  frmMain.txtPLUSgg = objGas.PLUSgg
  frmMain.txtMFN = objGas.mfN
  frmMain.txtMFCO2 = objGas.mfCO2
  frmMain.txtMFHS = objGas.mfH2S
  
  frmMain.txtPPM = objWat.PPM
  
  frmMain.optRock(0).Value = (objRock.Fluids = 0)
  frmMain.optType(0).Value = (objRock.Displace = 0)
  frmMain.optLith(0).Value = (objRock.Lith = 0)
  frmMain.optWet(0).Value = (objRock.Wet = 0)
  frmMain.optCorr(0).Value = (objRock.CORR = 0)
  frmMain.txtSWC = objRock.SWC
  frmMain.txtSORW = objRock.SORW
  frmMain.txtSORG = objRock.SORG
  frmMain.txtSGCrit = objRock.SGCrit
  frmMain.txtK = objRock.CoreyK
  frmMain.txtN = objRock.CoreyN
  frmMain.txtHRPoro = objRock.HRPoro
  frmMain.txtHRAir = objRock.HRAir
  frmMain.txtHRKrg = objRock.HRKrg
End Sub

Public Sub InitRockForm()
  frmMain.txtSORW.Enabled = False
  frmMain.lblSORW.Enabled = False
  frmMain.txtSORG.Enabled = False
  frmMain.lblSORG.Enabled = False
  frmMain.txtSGCrit.Enabled = False
  frmMain.lblSGCrit.Enabled = False
  
  frmMain.optWet(0).Enabled = False
  frmMain.optWet(1).Enabled = False
  
  frmMain.optCorr(0).Enabled = False
  frmMain.optCorr(1).Enabled = False

  frmMain.txtK.Enabled = False
  frmMain.lblK.Enabled = False
  frmMain.txtN.Enabled = False
  frmMain.lblN.Enabled = False
  
  If objRock.Fluids = 0 Then
    frmMain.optWet(0).Enabled = True
    frmMain.optWet(1).Enabled = True
    
    If objRock.Displace = 1 Then
      frmMain.txtSORW.Enabled = True
      frmMain.lblSORW.Enabled = True
    End If
  End If

  If objRock.Fluids = 1 Then
    frmMain.txtSGCrit.Enabled = True
    frmMain.lblSGCrit.Enabled = True
    
    If objRock.Displace = 1 Then
      frmMain.txtSORG.Enabled = True
      frmMain.lblSORG.Enabled = True
    End If
  End If

  If objRock.Displace = 0 Then
    frmMain.optCorr(0).Enabled = True
    frmMain.optCorr(0).Value = True
  End If

  If objRock.Displace = 1 Then
    frmMain.optCorr(0).Enabled = True
    frmMain.optCorr(1).Enabled = True
  End If

  If objRock.CORR = 0 Then
    frmMain.txtK.Enabled = True
    frmMain.lblK.Enabled = True
    frmMain.txtN.Enabled = True
    frmMain.lblN.Enabled = True
  End If
End Sub

Public Sub SetCoreyExp()
  frmMain.txtK.Enabled = False
  frmMain.lblK.Enabled = False
  frmMain.txtN.Enabled = False
  frmMain.lblN.Enabled = False
  
  frmMain.txtHRAir.Enabled = False
  frmMain.lblHRAir.Enabled = False
  frmMain.txtHRPoro.Enabled = False
  frmMain.lblHRPoro.Enabled = False
  frmMain.txtHRKrg.Enabled = False
  frmMain.lblHRKrg.Enabled = False
  frmMain.lblMD.Enabled = False
  frmMain.lblSORGU.Enabled = False

  If objRock.CORR = 0 Then
    frmMain.txtK.Enabled = True
    frmMain.lblK.Enabled = True
    frmMain.txtN.Enabled = True
    frmMain.lblN.Enabled = True
  End If

  If objRock.CORR = 1 Then
    frmMain.txtHRAir.Enabled = True
    frmMain.lblHRAir.Enabled = True
    frmMain.txtHRPoro.Enabled = True
    frmMain.lblHRPoro.Enabled = True
    frmMain.txtHRKrg.Enabled = True
    frmMain.lblHRKrg.Enabled = True
    frmMain.lblMD.Enabled = True
    frmMain.lblSORGU.Enabled = True
  End If
End Sub

