﻿
Option Explicit On
Imports System.IO
Imports System.Text

Public Class frmCSV

    Private Sub frmCSV_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        Me.Dispose()
    End Sub

    Private Sub frmCSV_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.chkOil.Checked = flagOil
        Me.chkOil.Enabled = flagOil

        Me.chkGas.Checked = flagGas
        Me.chkGas.Enabled = flagGas

        Me.chkWater.Checked = flagWater
        Me.chkWater.Enabled = flagWater

        Me.chkRock.Checked = flagRock
        Me.chkRock.Enabled = flagRock

        Me.txtPath.Text = "C:\MHA\P3\"
        Me.txtName.Text = "P3.csv"
    End Sub

    Private Sub cmdCancel_Click(sender As Object, e As EventArgs) Handles cmdCancel.Click
        Me.Close()
    End Sub

    Private Sub cmdExport_Click(sender As Object, e As EventArgs) Handles cmdExport.Click
        Dim objFILE As System.IO.StreamWriter
        Dim fileSPEC As String
        '
        '---Check if any phases selected
        '
        If Not Me.chkGas.Checked And Not Me.chkOil.Checked And Not Me.chkWater.Checked And Not Me.chkRock.Checked Then
            ErrMSG("No Properties checked.  Please select at least one export item.", "No Export")
            Exit Sub
        End If
        '
        '---Make folder
        '
        Try
            My.Computer.FileSystem.CreateDirectory(Me.txtPath.Text)
        Catch ex As Exception
            ErrMSG("Invalid Path.  Please re-enter", "Bad Path")
            Exit Sub
        End Try
        '
        '---Open file
        '
        fileSPEC = Me.txtPath.Text & Me.txtName.Text
        Try
            objFILE = My.Computer.FileSystem.OpenTextFileWriter(fileSPEC, False, Encoding.ASCII)
        Catch ex As Exception
            ErrMSG("Invalid file or path name.  Please re-enter.", "Bad File name")
            Exit Sub
        End Try

        If Me.chkGas.Checked Or Me.chkOil.Checked Or Me.chkWater.Checked Then
            objFILE.WriteLine("Standard Pressure (psia):," & STDPRS)
            objFILE.WriteLine("Temp (F):," & STDTMP)
            objFILE.WriteLine("Reservoir Temp (F):," & RESTEMP)
        End If

        If Me.chkOil.Checked Then csvOil(objFILE)
        If Me.chkGas.Checked Or Me.chkOil.Checked Then csvGas(objFILE)
        If Me.chkWater.Checked Then csvWater(objFILE)
        If Me.chkRock.Checked Then csvRock(objFILE)

        objFILE.Close()

        Process.Start(fileSPEC)
        Me.Close()
    End Sub
    '
    '---Gas Properties
    '
    Private Sub csvGas(objFILE As System.IO.StreamWriter)
        Dim ii As Int32

        objFILE.WriteLine(vbNewLine & "Gas Properties:" & vbNewLine)
        If frmStart.rdoGI.Checked Then
            objFILE.WriteLine("Gas Gravity:," & G)
            objFILE.WriteLine("Nitrogen (mole frac):," & YN2)
            objFILE.WriteLine("Carbon Dioxide (mole frac):," & YCO2)
            objFILE.WriteLine("Hydrogen Sulfide (mole frac):," & YH2S)
        Else
            objFILE.WriteLine(frmStart.txtGC1.Tag & ":," & frmStart.txtGC1.Text)
            objFILE.WriteLine(frmStart.txtGC2.Tag & ":," & frmStart.txtGC2.Text)
            objFILE.WriteLine(frmStart.txtGC3.Tag & ":," & frmStart.txtGC3.Text)
            objFILE.WriteLine(frmStart.txtGC4.Tag & ":," & frmStart.txtGC4.Text)
            objFILE.WriteLine(frmStart.txtGC5.Tag & ":," & frmStart.txtGC5.Text)
            objFILE.WriteLine(frmStart.txtGC6.Tag & ":," & frmStart.txtGC6.Text)
            objFILE.WriteLine(frmStart.txtGC7.Tag & ":," & frmStart.txtGC7.Text)
            objFILE.WriteLine(frmStart.txtGC8.Tag & ":," & frmStart.txtGC8.Text)
            objFILE.WriteLine(frmStart.txtGC9.Tag & ":," & frmStart.txtGC9.Text)
            objFILE.WriteLine(frmStart.txtGC10.Tag & ":," & frmStart.txtGC10.Text)
            objFILE.WriteLine(frmStart.txtGC11.Tag & ":," & frmStart.txtGC11.Text)
            objFILE.WriteLine(frmStart.txtGC12.Tag & ":," & frmStart.txtGC12.Text)

            objFILE.WriteLine(frmStart.txtNGC.Tag & ":," & frmStart.txtNGC.Text)
            objFILE.WriteLine(frmStart.txtDX.Tag & ":," & frmStart.txtDX.Text)
            objFILE.WriteLine(frmStart.txtSU.Tag & ":," & frmStart.txtSU.Text)
        End If

        objFILE.WriteLine(vbNewLine)
        objFILE.WriteLine("Critical Pressure (psia):," & frmStart.txtGPcp.Text)
        objFILE.WriteLine("Critical Temperature (R):," & frmStart.txtGPct.Text)
        objFILE.WriteLine("Pseudo-Reduced Temperature:," & frmStart.txtGPpt.Text)
        objFILE.WriteLine("StockTank Gas Density (lb/scf):," & frmStart.txtGPtgd.Text)
        objFILE.WriteLine(vbNewLine)

        With frmStart.dgvGP
            objFILE.WriteLine(.Columns(0).HeaderText & "," & .Columns(1).HeaderText & "," & .Columns(2).HeaderText & "," & .Columns(3).HeaderText & "," & _
                              .Columns(4).HeaderText & "," & .Columns(5).HeaderText & "," & .Columns(6).HeaderText & "," & .Columns(7).HeaderText & "," & _
                              .Columns(8).HeaderText)
            For ii = 0 To .RowCount - 1
                objFILE.WriteLine(.Rows(ii).Cells(0).Value & "," & .Rows(ii).Cells(1).Value & "," & .Rows(ii).Cells(2).Value & "," & _
                                  .Rows(ii).Cells(3).Value & "," & .Rows(ii).Cells(4).Value & "," & .Rows(ii).Cells(5).Value & "," & _
                                  .Rows(ii).Cells(6).Value & "," & .Rows(ii).Cells(7).Value & "," & .Rows(ii).Cells(8).Value)
            Next ii
        End With

    End Sub
    '
    '---Water Properties
    '
    Private Sub csvWater(objFILE As System.IO.StreamWriter)
        Dim ii As Int32

        objFILE.WriteLine(vbNewLine & "Water Properties:" & vbNewLine)
        objFILE.WriteLine("Water Salinity (ppm):," & frmStart.txtWSppm.Text)
        objFILE.WriteLine("Water Salinity (wt% solids):," & frmStart.txtWSwt.Text)

        objFILE.WriteLine(vbNewLine)
        objFILE.WriteLine("Reservoir Temperature (F):," & frmStart.txtWPrtemp.Text)
        objFILE.WriteLine("Weight % Solids:," & frmStart.txtWPweight.Text)
        objFILE.WriteLine("Dissolved Solids (ppm):," & frmStart.txtWPdiss.Text)
        objFILE.WriteLine("Tank Water Density (lb/scf):," & frmStart.txtWPtwd.Text)
        objFILE.WriteLine(vbNewLine)

        With frmStart.dgvWP
            objFILE.WriteLine(.Columns(0).HeaderText & "," & .Columns(1).HeaderText & "," & .Columns(2).HeaderText & "," & .Columns(3).HeaderText & "," & _
                              .Columns(4).HeaderText & "," & .Columns(5).HeaderText)
            For ii = 0 To .RowCount - 1
                objFILE.WriteLine(.Rows(ii).Cells(0).Value & "," & .Rows(ii).Cells(1).Value & "," & .Rows(ii).Cells(2).Value & "," & _
                                  .Rows(ii).Cells(3).Value & "," & .Rows(ii).Cells(4).Value & "," & .Rows(ii).Cells(5).Value)
            Next ii
        End With

    End Sub
    '
    '---Oil Properties
    '
    Private Sub csvOil(objFILE As System.IO.StreamWriter)
        Dim ii As Int32

        objFILE.WriteLine(vbNewLine & "Oil Properties:" & vbNewLine)

        objFILE.WriteLine("API Gravity:," & API)
        objFILE.WriteLine("Specific Gravity:," & SGOILSC)
        objFILE.WriteLine("Separator Gas Gravity:," & GSEP)
        objFILE.WriteLine("Separator Pressure (psia):," & PSEP)
        objFILE.WriteLine("Separator Temp (F):," & TSEP)

        objFILE.WriteLine("Bubble Pt Pres (psia):," & PBP.ToString("F1").PadLeft(10, " "))
        objFILE.WriteLine("Compressibility @ Pbp:," & CO(IPBP).ToString("F7").PadLeft(10, " "))

        objFILE.WriteLine("StockTank Oil Density (lb/scf):," & STDENOIL.ToString("F3").PadLeft(10, " "))
        objFILE.WriteLine("StockTank Gas Density (lb/scf):," & STDENGAS.ToString("F5").PadLeft(10, " "))
        objFILE.WriteLine("Initial GOR-Separator (scf/stb):," & RSISEP.ToString("F1").PadLeft(10, " "))
        objFILE.WriteLine("StockTank (scf/stb):," & RSITANK.ToString("F1").PadLeft(10, " "))
        objFILE.WriteLine("Total (scf/stb):," & RSI.ToString("F1").PadLeft(10, " "))

        objFILE.WriteLine(vbNewLine)
        objFILE.WriteLine("Undersaturated properties:")
        objFILE.WriteLine(vbNewLine)

        objFILE.WriteLine(",,Volume,Dissolved")
        objFILE.WriteLine(",Pressure,Factor,GOR,Viscosity,Density")
        objFILE.WriteLine(",(psia),(rb/stb),(scf/stb),(cp),(lb/ft3)")

        For ii = 1 To NPVTPRS
            objFILE.Write("," & PVTPRS(ii).ToString("F1").PadLeft(11, " ") & ",")
            objFILE.Write(BO(ii).ToString("F4").PadLeft(12, " ") & ",")
            objFILE.Write(RSO(ii).ToString("F1").PadLeft(11, " ") & ",")
            objFILE.Write(MUO(ii).ToString("F3").PadLeft(12, " ") & ",")
            objFILE.WriteLine(RHOO(ii).ToString("F3").PadLeft(13, " "))
        Next ii

        objFILE.WriteLine(vbNewLine)
        objFILE.WriteLine(vbNewLine)
        objFILE.WriteLine("Saturated properties:")
        objFILE.WriteLine(vbNewLine)

        objFILE.WriteLine(",,Volume,Dissolved")
        objFILE.WriteLine(",Pressure,Factor,GOR,Viscosity,Density")
        objFILE.WriteLine(",(psia),(rb/stb),(scf/stb),(cp),(lb/ft3)")

        For ii = 1 To NPVTPRS
            objFILE.Write("," & PVTPRS(ii).ToString("F1").PadLeft(11, " ") & ",")
            objFILE.Write(BOS(ii).ToString("F4").PadLeft(12, " ") & ",")
            objFILE.Write(RSOS(ii).ToString("F1").PadLeft(11, " ") & ",")
            objFILE.Write(MUOS(ii).ToString("F3").PadLeft(12, " ") & ",")
            objFILE.WriteLine(RHOOS(ii).ToString("F3").PadLeft(13, " "))
        Next ii
    End Sub

    Private Sub csvRock(objFILE As System.IO.StreamWriter)

        objFILE.WriteLine(vbNewLine)
        objFILE.WriteLine("Rock Properties:")
        objFILE.WriteLine(vbNewLine)

        Select Case optRockFluids
            Case 0 : objFILE.WriteLine("Fluids:, Oil/Water System")
            Case 1 : objFILE.WriteLine("Fluids:, Gas/Oil System")
        End Select

        Select Case optRockDisplace
            Case 0 : objFILE.WriteLine("Displacement:, Drainage")
            Case 1 : objFILE.WriteLine("Displacement:, Imbibition")
        End Select

        If optRockCorr = 0 Then
            objFILE.WriteLine("Lithology:, N/A")
        Else
            Select Case optRockLith
                Case 0 : objFILE.WriteLine("Lithology:, Sandstone")
                Case 1 : objFILE.WriteLine("Lithology:, Limestone")
            End Select
        End If

        objFILE.WriteLine("Connate Water:," & SWC.ToString("F2").PadLeft(8, " "))

        If optRockFluids = 0 Then                           'Oil/Water system

            Select Case optRockWet
                Case 0 : objFILE.WriteLine("Wettability:, Water Wet")
                Case 1 : objFILE.WriteLine("Wettability:, Oil Wet")
            End Select

            objFILE.WriteLine("Residual Oil to Water:," & SORW.ToString("F2").PadLeft(8, " "))
        End If

        If optRockFluids = 1 Then                           'Gas/Oil system
            objFILE.WriteLine("Residual Oil to Gas:," & SWC.ToString("F2").PadLeft(8, " "))
            objFILE.WriteLine("Critical Gas:," & SWC.ToString("F2").PadLeft(8, " "))
        End If

        Select Case optRockCorr
            Case 0
                objFILE.WriteLine("Correlation Type:, Corey")
                objFILE.WriteLine("K Exponent:," & CoreyK.ToString("F2").PadLeft(5, " "))
                objFILE.WriteLine("N Exponent:," & CoreyN.ToString("F2").PadLeft(5, " "))
            Case 1
                objFILE.WriteLine("Correlation Type:, Honarpour")
                objFILE.WriteLine("Porosity (frac):," & HRPoro.ToString("F2").PadLeft(6, " "))
                objFILE.WriteLine("Air Perm (md)," & HRAir.ToString("F2").PadLeft(6, " "))
                objFILE.WriteLine("Krg @Sorg:," & HRKrg.ToString("F2").PadLeft(6, " "))
        End Select

        objFILE.WriteLine("Compressibility: " & NewmanCF.ToString("E7"))

        If optRockFluids = 0 Then                           'Oil/Water system
            objFILE.WriteLine(vbNewLine)
            objFILE.WriteLine(",Saturations,,Relative Permeability")
            objFILE.WriteLine(",Water,Oil,Water,Oil")

            For ii = 1 To NWet
                objFILE.Write("," & pvtSWet(ii).ToString("F2").PadLeft(11, " ") & ",")
                objFILE.Write(pvtSNWet(ii).ToString("F2").PadLeft(12, " ") & ",")
                objFILE.Write(pvtKRWat(ii).ToString("F4").PadLeft(12, " ") & ",")
                objFILE.WriteLine(pvtKROil(ii).ToString("F4").PadLeft(12, " "))
            Next ii
        End If

        If optRockFluids = 1 Then                           'Gas/Oil system
            objFILE.WriteLine(vbNewLine)
            objFILE.WriteLine(",Saturations,,,Relative Permeability")
            objFILE.WriteLine(",Gas,Soil,Swater,Gas,Oil")

            For ii = 1 To NWet
                objFILE.Write("," & pvtSNWet(ii).ToString("F2").PadLeft(11, " ") & ",")
                objFILE.Write((pvtSWet(ii) - SWC).ToString("F2").PadLeft(12, " ") & ",")
                objFILE.Write(SWC.ToString("F2").PadLeft(12, " ") & ",")
                objFILE.Write(pvtKRGas(ii).ToString("F4").PadLeft(12, " ") & ",")
                objFILE.WriteLine(pvtKROil(ii).ToString("F4").PadLeft(12, " "))
            Next ii
        End If
    End Sub

    Private Sub txtName_Validating(sender As Object, e As System.ComponentModel.CancelEventArgs) Handles txtName.Validating
        If Not Me.txtName.Text.ToUpper.EndsWith(".CSV") Then
            ErrMSG("Please specify a CSV file type.", "CSV Only")
            e.Cancel = True
        End If
    End Sub

   
End Class