﻿
Option Explicit On
Imports System.IO
Imports System.Text

Public Class frmReport

    Private Sub frmReport_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        Me.Dispose()
    End Sub

    Private Sub frmReport_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        Me.chkOil.Checked = flagOil
        Me.chkOil.Enabled = flagOil

        Me.chkGas.Checked = flagGas Or flagOil
        Me.chkGas.Enabled = flagGas Or flagOil

        Me.chkWater.Checked = flagWater
        Me.chkWater.Enabled = flagWater

        Me.chkRock.Checked = flagRock
        Me.chkRock.Enabled = flagRock

        Me.txtPath.Text = "C:\MHA\P3\"
        Me.txtName.Text = "Sample.txt"


    End Sub

    Private Sub cmdCancel_Click(sender As Object, e As EventArgs) Handles cmdCancel.Click
        Me.Close()
    End Sub

    Private Sub cmdRun_Click(sender As Object, e As EventArgs) Handles cmdRun.Click
        Dim objFILE As System.IO.StreamWriter
        Dim fileSPEC As String
        '
        '---Check if any phases selected
        '
        If Not Me.chkGas.Checked And Not Me.chkOil.Checked And Not Me.chkWater.Checked And Not Me.chkRock.Checked Then
            ErrMSG("No Properties checked.  Please select at least one report item.", "No Report")
            Exit Sub
        End If
        '
        '---Check if rock prop needs to br re-run
        '
        If optRockFluids = 0 And frmStart.dgvRock.Columns.Count <> 5 Then
            ErrMSG("Please re-run Rock Properties before running report.", "Re-Run")
            Exit Sub
        End If
        If optRockFluids = 1 And frmStart.dgvRock.Columns.Count <> 6 Then
            ErrMSG("Please re-run Rock Properties before running report.", "Re-Run")
            Exit Sub
        End If
        '
        '---Make folder
        '
        Try
            My.Computer.FileSystem.CreateDirectory(Me.txtPath.Text)
        Catch ex As Exception
            ErrMSG("Invalid Path.  Please re-enter", "Bad Path")
            Exit Sub
        End Try
        '
        '---Open file
        '
        fileSPEC = Me.txtPath.Text & Me.txtName.Text
        Try
            objFILE = My.Computer.FileSystem.OpenTextFileWriter(fileSPEC, False, Encoding.ASCII)

        Catch ex As Exception
            ErrMSG("Invalid file or path name.  Please re-enter.", "Bad File name")
            Exit Sub
        End Try
        '
        '---Report header
        '
        ReportHeader(objFILE)
        If Me.chkOil.Checked Then ReportOil(objFILE)
        If Me.chkGas.Checked Or Me.chkOil.Checked Then ReportGas(objFILE)
        If Me.chkWater.Checked Then ReportWater(objFILE)
        If Me.chkRock.Checked Then ReportRock(objFILE)

        objFILE.Close()

        Process.Start(fileSPEC)
        Me.Close()
    End Sub
    '
    '---Report header
    '
    Private Sub ReportHeader(objFILE As System.IO.StreamWriter)
        objFILE.WriteLine("MHA Petroleum Consultants LLC" & vbTab & vbTab & Date.Today.ToString("D"))
        objFILE.WriteLine(APP_NAME & " " & strP3version & vbNewLine & vbNewLine & vbNewLine)

        objFILE.WriteLine("Company: " & Me.txtCompany.Text)
        objFILE.WriteLine("Field: " & Me.txtField.Text)
        objFILE.WriteLine("Reservoir: " & Me.txtRes.Text)
        objFILE.WriteLine("Location: " & Me.txtLoc.Text)
        objFILE.WriteLine("Engineer: " & Me.txtBy.Text)

        objFILE.WriteLine(vbNewLine & vbNewLine & "----------------------------------" & vbNewLine & "   STANDARD CONDITIONS" & vbNewLine & "----------------------------------" & vbNewLine)

        objFILE.WriteLine("Standard Pressure: " & STDPRS & " (psia)")
        objFILE.WriteLine("Temp: " & STDTMP & " (F)")
        objFILE.WriteLine("Reservoir Temp: " & RESTEMP & " (F)")
    End Sub
    '
    '---Gas Properties
    '
    Private Sub ReportGas(objFILE As System.IO.StreamWriter)
        Dim ii As Int32
        objFILE.WriteLine(vbNewLine & vbNewLine & "----------------------------------" & vbNewLine & "   GAS PROPERTIES" & vbNewLine & "----------------------------------" & vbNewLine)
        If frmStart.rdoGI.Checked Then
            objFILE.WriteLine("Gas Gravity and Inerts" & vbNewLine)
            objFILE.WriteLine("Gas Gravity: " & G)
            objFILE.WriteLine("Nitrogen, mole frac: " & YN2)
            objFILE.WriteLine("Carbon Dioxide, mole frac: " & YCO2)
            objFILE.WriteLine("Hydrogen Sulfide, mole frac: " & YH2S)
        Else
            objFILE.WriteLine("Gas Composition" & vbNewLine)
            objFILE.WriteLine(frmStart.txtGC1.Tag & ": " & frmStart.txtGC1.Text)
            objFILE.WriteLine(frmStart.txtGC2.Tag & ": " & frmStart.txtGC2.Text)
            objFILE.WriteLine(frmStart.txtGC3.Tag & ": " & frmStart.txtGC3.Text)
            objFILE.WriteLine(frmStart.txtGC4.Tag & ": " & frmStart.txtGC4.Text)
            objFILE.WriteLine(frmStart.txtGC5.Tag & ": " & frmStart.txtGC5.Text)
            objFILE.WriteLine(frmStart.txtGC6.Tag & ": " & frmStart.txtGC6.Text)
            objFILE.WriteLine(frmStart.txtGC7.Tag & ": " & frmStart.txtGC7.Text)
            objFILE.WriteLine(frmStart.txtGC8.Tag & ": " & frmStart.txtGC8.Text)
            objFILE.WriteLine(frmStart.txtGC9.Tag & ": " & frmStart.txtGC9.Text)
            objFILE.WriteLine(frmStart.txtGC10.Tag & ": " & frmStart.txtGC10.Text)
            objFILE.WriteLine(frmStart.txtGC11.Tag & ": " & frmStart.txtGC11.Text)
            objFILE.WriteLine(frmStart.txtGC12.Tag & ": " & frmStart.txtGC12.Text)

            objFILE.WriteLine(frmStart.txtNGC.Tag & ": " & frmStart.txtNGC.Text)
            objFILE.WriteLine(frmStart.txtDX.Tag & ": " & frmStart.txtDX.Text)
            objFILE.WriteLine(frmStart.txtSU.Tag & ": " & frmStart.txtSU.Text)
        End If

        objFILE.WriteLine(vbNewLine)
        objFILE.WriteLine("Critical Pressure: " & frmStart.txtGPcp.Text & " (psia)")
        objFILE.WriteLine("Critical Temperature: " & frmStart.txtGPct.Text & " (R)")
        objFILE.WriteLine("Pseudo-Reduced Temperature: " & frmStart.txtGPpt.Text)
        objFILE.WriteLine("StockTank Gas Density: " & frmStart.txtGPtgd.Text & " (lb/scf)" & vbNewLine)


        With frmStart.dgvGP
            objFILE.WriteLine(.Columns(0).HeaderText & vbTab & .Columns(1).HeaderText & vbTab & .Columns(2).HeaderText & vbTab & .Columns(3).HeaderText & vbTab & _
                              .Columns(4).HeaderText & vbTab & .Columns(5).HeaderText & vbTab & .Columns(6).HeaderText & vbTab & .Columns(7).HeaderText & vbTab & _
                              .Columns(8).HeaderText)
            For ii = 0 To .RowCount - 1
                objFILE.WriteLine(.Rows(ii).Cells(0).Value & vbTab & vbTab & .Rows(ii).Cells(1).Value & vbTab & vbTab & .Rows(ii).Cells(2).Value & vbTab & _
                                  .Rows(ii).Cells(3).Value & vbTab & vbTab & .Rows(ii).Cells(4).Value & vbTab & .Rows(ii).Cells(5).Value & vbTab & vbTab & _
                                  .Rows(ii).Cells(6).Value & vbTab & .Rows(ii).Cells(7).Value & vbTab & vbTab & .Rows(ii).Cells(8).Value)
            Next ii
        End With

    End Sub
    '
    '---Water Properties
    '
    Private Sub ReportWater(objFILE As System.IO.StreamWriter)
        Dim ii As Int32
        objFILE.WriteLine(vbNewLine & vbNewLine & "----------------------------------" & vbNewLine & "   WATER PROPERTIES" & vbNewLine & "----------------------------------" & vbNewLine)

        objFILE.WriteLine("Water Salinity (ppm): " & frmStart.txtWSppm.Text)
        objFILE.WriteLine("Water Salinity (wt% solids): " & frmStart.txtWSwt.Text)

        objFILE.WriteLine(vbNewLine)
        objFILE.WriteLine("Reservoir Temperature: " & frmStart.txtWPrtemp.Text & " (F)")
        objFILE.WriteLine("Weight % Solids: " & frmStart.txtWPweight.Text)
        objFILE.WriteLine("Dissolved Solids: " & frmStart.txtWPdiss.Text & " (ppm)")
        objFILE.WriteLine("Tank Water Density: " & frmStart.txtWPtwd.Text & " (lb/scf)" & vbNewLine)

        With frmStart.dgvWP
            objFILE.WriteLine(.Columns(0).HeaderText & vbTab & .Columns(1).HeaderText & vbTab & .Columns(2).HeaderText & vbTab & .Columns(3).HeaderText & vbTab & _
                              .Columns(4).HeaderText & vbTab & .Columns(5).HeaderText)
            For ii = 0 To .RowCount - 1
                objFILE.WriteLine(.Rows(ii).Cells(0).Value & vbTab & vbTab & .Rows(ii).Cells(1).Value & vbTab & vbTab & .Rows(ii).Cells(2).Value & vbTab & vbTab & _
                                  .Rows(ii).Cells(3).Value & vbTab & vbTab & .Rows(ii).Cells(4).Value & vbTab & .Rows(ii).Cells(5).Value)
            Next ii
        End With

    End Sub
    '
    '---Oil Properties
    '
    Private Sub ReportOil(objFILE As System.IO.StreamWriter)
        Dim ii As Int32
        objFILE.WriteLine(vbNewLine & vbNewLine & "----------------------------------" & vbNewLine & "   OIL PROPERTIES" & vbNewLine & "----------------------------------" & vbNewLine)

        objFILE.WriteLine("API Gravity: " & frmStart.txtOilAPI.Text)
        objFILE.WriteLine("Specific Gravity: " & frmStart.txtOilSG.Text)
        objFILE.WriteLine("Separator Gas Gravity: " & frmStart.txtSepGG.Text)
        objFILE.WriteLine("Pressure: 50 (psia)")
        objFILE.WriteLine("Temp: 75 (F)")

        objFILE.WriteLine(vbNewLine)
        objFILE.WriteLine("Bubble Point Pressure: " & frmStart.txtOPbp.Text & " (psia)")
        objFILE.WriteLine("Compressibility @ Pbp: " & frmStart.txtOPComp.Text & " (psia)")
        objFILE.WriteLine("StockTank Oil Density: " & frmStart.txtOPtod.Text & " (lb/scf)")
        objFILE.WriteLine("StockTank Gas Density: " & STDENGAS.ToString("F5") & " (lb/scf)")

        objFILE.WriteLine("Initial GOR-Separato: " & frmStart.txtOPGORsep.Text & " (scf/stb)")
        objFILE.WriteLine("Stock Tank: " & frmStart.txtOPGORtank.Text & " (scf/stb)")
        objFILE.WriteLine("Total:      : " & frmStart.txtOPGORinit.Text & " (scf/stb)")

        objFILE.WriteLine(vbNewLine)
        objFILE.WriteLine("Undersaturated properties above the bubble point:")
        objFILE.WriteLine(vbNewLine)

        With frmStart.dgvOP
            objFILE.WriteLine(.Columns(0).HeaderText & vbTab & .Columns(1).HeaderText & vbTab & .Columns(2).HeaderText & vbTab & .Columns(3).HeaderText & vbTab & _
                              .Columns(4).HeaderText)
            For ii = 0 To .RowCount - 1
                objFILE.WriteLine(.Rows(ii).Cells(0).Value & vbTab & vbTab & .Rows(ii).Cells(1).Value & vbTab & vbTab & .Rows(ii).Cells(2).Value & vbTab & vbTab & _
                                  .Rows(ii).Cells(3).Value & vbTab & vbTab & .Rows(ii).Cells(4).Value)
            Next ii

            objFILE.WriteLine(vbNewLine)
            objFILE.WriteLine("Extended Saturated oil properties:")
            objFILE.WriteLine(vbNewLine)

            objFILE.WriteLine(.Columns(0).HeaderText & vbTab & .Columns(6).HeaderText & vbTab & .Columns(7).HeaderText & vbTab & .Columns(8).HeaderText & vbTab & _
                              .Columns(9).HeaderText)
            For ii = 0 To .RowCount - 1
                objFILE.WriteLine(.Rows(ii).Cells(0).Value & vbTab & vbTab & .Rows(ii).Cells(6).Value & vbTab & vbTab & .Rows(ii).Cells(7).Value & vbTab & vbTab & _
                                  .Rows(ii).Cells(8).Value & vbTab & vbTab & .Rows(ii).Cells(9).Value)
            Next ii
        End With

    End Sub
    '
    '---Rock Properties
    '
    Private Sub ReportRock(objFILE As System.IO.StreamWriter)
        Dim ii As Int32
        '
        '---Check if rock prop needs to br re-run
        '
        If optRockFluids = 0 And frmStart.dgvRock.Columns.Count <> 5 Then
            ErrMSG("Please re-run Rock Properties before running report.", "Re-Run")
            Exit Sub
        End If
        If optRockFluids = 1 And frmStart.dgvRock.Columns.Count <> 6 Then
            ErrMSG("Please re-run Rock Properties before running report.", "Re-Run")
            Exit Sub
        End If

        objFILE.WriteLine(vbNewLine & vbNewLine & "----------------------------------" & vbNewLine & "   ROCK PROPERTIES" & vbNewLine & "----------------------------------" & vbNewLine)

        Select Case optRockFluids
            Case 0 : objFILE.WriteLine("Fluids: Oil/Water System")
            Case 1 : objFILE.WriteLine("Fluids: Gas/Oil System")
        End Select

        Select Case optRockDisplace
            Case 0 : objFILE.WriteLine("Displacement: Drainage")
            Case 1 : objFILE.WriteLine("Displacement: Imbibition")
        End Select

        Select Case optRockLith
            Case 0 : objFILE.WriteLine("Lithology: Sandstone")
            Case 1 : objFILE.WriteLine("Lithology: Limestone")
        End Select

        objFILE.WriteLine("Connate Water: " & SWC.ToString("F2").PadRight(8, " "))

        If optRockFluids = 0 Then                           'Oil/Water system
            Select Case optRockWet
                Case 0 : objFILE.WriteLine("Wettability: Water Wet")
                Case 1 : objFILE.WriteLine("Wettability: Oil Wet")
            End Select
            objFILE.WriteLine("Residual Oil to Water: " & SORW.ToString("F2").PadRight(8, " "))
        End If

        If optRockFluids = 1 Then                           'Gas/Oil system
            objFILE.WriteLine("Residual Oil to Gas: " & SWC.ToString("F2").PadRight(8, " "))
            objFILE.WriteLine("Critical Gas: " & SGCrit.ToString("F2").PadRight(8, " "))
        End If
        objFILE.WriteLine(vbNewLine)

        Select Case optRockCorr
            Case 0 : objFILE.WriteLine("Correlation Type: Corey")
            Case 1 : objFILE.WriteLine("Correlation Type: Honarpour")
        End Select

        If optRockCorr = 0 Then
            objFILE.WriteLine("K Exponent: " & CoreyK.ToString("F2").PadRight(5, " "))
            objFILE.WriteLine("N Exponent: " & CoreyN.ToString("F2").PadRight(5, " "))
        Else
            objFILE.WriteLine("Porosity (frac): " & HRPoro.ToString("F2").PadRight(6, " "))
            objFILE.WriteLine("Air Perm (md): " & HRAir.ToString("F2").PadRight(6, " "))
            objFILE.WriteLine("Krg @Sorg: " & HRKrg.ToString("F2").PadRight(6, " "))
        End If

        objFILE.WriteLine("Compressibility: " & NewmanCF.ToString("E7"))

        If optRockFluids = 0 Then                           'Oil/Water system
            objFILE.WriteLine(vbNewLine)

            With frmStart.dgvRock
                objFILE.WriteLine(.Columns(0).HeaderText & vbTab & vbTab & .Columns(1).HeaderText & vbTab & .Columns(3).HeaderText & vbTab & _
                                  vbTab & .Columns(4).HeaderText)

                For ii = 0 To .RowCount - 1
                    objFILE.WriteLine(.Rows(ii).Cells(0).Value & vbTab & vbTab & .Rows(ii).Cells(1).Value & vbTab & _
                                      .Rows(ii).Cells(3).Value & vbTab & .Rows(ii).Cells(4).Value)
                Next ii
            End With
        End If

        If optRockFluids = 1 Then                           'Gas/Oil system
            objFILE.WriteLine(vbNewLine)

            With frmStart.dgvRock
                objFILE.WriteLine(.Columns(0).HeaderText & vbTab & vbTab & .Columns(1).HeaderText & vbTab & vbTab & .Columns(2).HeaderText & vbTab & _
                                  .Columns(4).HeaderText & vbTab & vbTab & .Columns(5).HeaderText)

                For ii = 0 To .RowCount - 1
                    objFILE.WriteLine(.Rows(ii).Cells(0).Value & vbTab & .Rows(ii).Cells(1).Value & vbTab & vbTab & .Rows(ii).Cells(2).Value & vbTab & vbTab & _
                                      .Rows(ii).Cells(4).Value & vbTab & .Rows(ii).Cells(5).Value)
                Next ii
            End With
        End If

    End Sub
End Class