﻿Option Explicit On

Module modMain
    Public APP_NAME = "Petroleum Properties Program"
    Public APP_ID = "P3"

    Public Const scrSizeH As int32 = 80          'Main form height (% of screen height)
    Public Const scrSizeW As Int32 = 75          'Main form width (% of screen width)

    Public bacCOLOR As Color = Color.White       'Grid background color
    Public selCOLOR As Color = Color.LightYellow 'Grid highlight color
    Public edtCOLOR As Color = Color.LightYellow 'Grid edited color
    Public minCOLOR As Color = Color.Beige       'Grid min eval color
    Public maxCOLOR As Color = Color.Gold        'Grid max eval color

    Public aliCC As DataGridViewContentAlignment = DataGridViewContentAlignment.MiddleCenter
    Public aliLC As DataGridViewContentAlignment = DataGridViewContentAlignment.MiddleLeft
    Public aliRC As DataGridViewContentAlignment = DataGridViewContentAlignment.MiddleRight

    Public RUN_DATE As Date

    Public userCLICK As Boolean                  'Prevents unwanted code side effects
    Public gridOP As New clsGrid                 'Pointer to fxgMain 
    Public gridGP As New clsGrid                 'Pointer to fxgLoad 
    Public gridWP As New clsGrid                 'Pointer to fxgCurve 
    Public gridRP As New clsGrid                 'Pointer to fxgCurve 

    Public flagOil As Boolean                    'Phase Oil present
    Public flagGas As Boolean                    'Phase Gas present
    Public flagWater As Boolean                  'Phase Water present
    Public flagNormalize As Boolean              'True if Normalize button pressed
    Public flagRock As Boolean                   'True if Normalize button pressed

    Public strP3version As String                'Version string

    'Public strLFileName As String               'Wellname of current loaded well
    'Public strStacked As String                 '"(**Stacked)"
    'Public strINSTALLED As String               'Path to lasUtilities installed directory
    'Public WELLINDEX As int32                    'Well index for output screens wizard

    'Public objTREE As New clsTree               'Pointer to LAS file tree window
    ''    Public objLWIZ As clsWIZARD                 'Pointer to log plot wizard controller
    'Public objEXPORT As clsExport               'Pointer to LAS file exporter
    'Public objLAS As clsLAS                     'Pointer to LAS format parser
    ''    Public objMDB As clsLasDBIO                 'Pointer to LAS_MASTER Database
    'Public objUtilDB As clsUtilDBIO             'Pointer to lasUtilities database
    ''    Public objProgMain As New clsProgBar        'Pointer to frmMain progress bar
    ''    Public objPLOT As New clsLogPlot            'Pointer to LogPlot class
    'Public strContinue As String                'Continue switch set in Splash form
    ''    Public objFORM As frmDetail                 'Pointer to detail form
    'Public checkSTACKED As Boolean              'TRUE if summary to detect stacked file
    'Public STACKED As Boolean                   'TRUE if current file is stacked

    'Public LOADCANCEL As Boolean                'TRUE if cancel current load operation
    'Public strOPTION As String                  'Form option
    'Public strProfileName As String             'Name of current profile
    'Public strProfileDesc As String             'Current profile description
    'Public strProfileType As String             'Current profile type (EXPORT or PLOT)
    'Public curProID As int32                     'ID of current profile
    'Public cancelOPT As String                  'Cancel FORM options ("FILE" or "LOAD")
    'Public mnemOPT As String                    'LAS Mnemeonic FORM options
    ''        ("CURVE", "WELL" or "PAR")

    'Public DetailOPT As String                  'Detail FORM options ("FILE" or "LOADED")
    'Public objDETAIL As clsWell                 'Well class pointer for DetailOPT=LOADED
    'Public optMERGE As Boolean                  'File Merge option allowed (same DUNITS & STEP)
    'Public currKEY As String                    'Current node key
    'Public lasPATH As String                    'Current node file path
    'Public lasFILE As String                    'Current node file name
    'Public PlotFlags() As Boolean               'Array of Quick Plot flags
    'Public pltCount As int32                     'Number of curves to plot

    Private Declare Function GetDesktopWindow Lib "user32" () As int32

    Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" _
            (ByVal hWnd As int32, ByVal lpOperation As String, ByVal lpFile _
             As String, ByVal lpParameters As String, ByVal lpDirectory As String, _
             ByVal nShowCmd As int32) As int32

    Private Const SW_SHOWNORMAL = 1

    '    Public Sub moveProgBar()
    '
    '        With frmMain.progMAIN
    '            .Left = frmMain.barMAIN.Panels(2).Left + 50
    '            .Top = frmMain.barMAIN.Top + 75
    '            .Height = frmMain.barMAIN.Height - 100
    '            .Width = frmMain.barMAIN.Panels(2).Width - 100
    '        End With

    'End Sub

    'Public Sub initProgBar(progIN As ProgressBar, barIN As StatusBar, panelIN as int32)

    '    With progIN
    '        .Left = barIN.Panels(panelIN).Left + 50
    '        .Top = barIN.Top + 75
    '        .Height = barIN.Height - 100
    '        .Width = barIN.Panels(panelIN).Width - 100
    '    End With

    '    progIN.Visible = True

    'End Sub

    'Public Sub sizeForm()
    '    Dim temp As Single
    '    '
    '    '---Reposition Static controls (abort if just minimized!)
    '    '
    '    If frmMain.WindowState = vbMinimized Then Exit Sub
    '    On Error Resume Next

    '    With frmMain
    '        Call moveProgBar()
    '        '
    '        '---Tool bar line
    '        '
    '        .linTop.X1 = .ScaleLeft
    '        .linTop.X2 = .ScaleWidth
    '        .linBot.X1 = .ScaleLeft
    '        .linBot.X2 = .ScaleWidth
    '        '
    '        '---Reposition summary and files flex grids
    '        '
    '        temp = .ScaleWidth - (.pctMain.Left + .pctMain.Width + 300)
    '        .fxgMain.Move.pctMain.Left(+.pctMain.Width + 200, .pctMain.Top, _
    '                           temp, .ScaleHeight / 2 - 1000)
    '        .lblPreview.Move.fxgMain.Left, .fxgMain.Top - .lblPreview.Height
    '        .fraLoad.Move.fxgMain.Left, .fxgMain.Top + .fxgMain.Height + 50
    '        .fraDelete.Move.fxgMain.Left(+.fxgMain.Width / 2 - 500, .fraLoad.Top - 250)
    '        .fxgMain.ZOrder()
    '.lblPATH.Move (.fxgMain.Left + .fxgMain.Width - .lblPATH.Width), _
    '              .fxgMain.Top - 225

    '        .fxgLoad.Move.fxgMain.Left, .fraLoad.Top + 600, _
    '                           temp, .ScaleHeight / 2 - 1200
    '        .lblLoad.Move.fxgLoad.Left, .fxgLoad.Top - .lblLoad.Height
    '        .fraClear.Move.fraLoad.Left(+.fxgLoad.Width / 2 - 500, _
    '                       .fxgLoad.Top + .fxgLoad.Height - 200)
    '        .fxgLoad.ZOrder()
    '        .treeLAS.Move.treeLAS.Left, .treeLAS.Top, .treeLAS.Width, _
    '                      (.fraClear.Top + .fraClear.Height) - .treeLAS.Top

    '        If gridMain.TotalRows > 0 Then
    '            .lblFileCount.Visible = True
    '            .lblFileCount.Move.fxgMain.Left(+.fxgMain.Width - .lblFileCount.Width, _
    '                               .fxgMain.Top + .fxgMain.Height + 100)
    '        End If

    '        If .fxgLoad.Rows > 0 Then
    '            .lblLoadCount.Visible = True
    '            .lblLoadCount.Move.fxgLoad.Left(+.fxgLoad.Width - .lblLoadCount.Width, _
    '                               .fxgLoad.Top + .fxgLoad.Height + 100)
    '        End If
    '    End With
    'End Sub

    'Private Sub Main()
    '    frmSplash.Show vbModal

    '    If strContinue = "YES" Then frmMain.Show()
    'End Sub

    Public Sub ErrMSG(emsg As String, etitle As String)
        MessageBox.Show(emsg, My.Application.Info.AssemblyName & " - " & etitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
    End Sub

    Public Sub InfoMSG(emsg As String, etitle As String)
        MessageBox.Show(emsg, etitle, MessageBoxButtons.OK, MessageBoxIcon.Information)
    End Sub

    Public Function Confirm(msgIN As String, titleIN As String) As Boolean


        Confirm = (MessageBox.Show(msgIN, titleIN, MessageBoxButtons.YesNo, MessageBoxIcon.Exclamation) = vbYes)
    End Function
    '
    'Public Sub MouseOver(imgIN As PictureBox, lblIN As Label)
    '  lblIN.ForeColor = &HFF8080
    '  imgIN.Visible = False
    '  frmMain.imgFuncX.Move imgIN.Left, imgIN.Top
    '  frmMain.imgFuncX.Visible = True
    'End Sub

    'Public Sub LoadFiles(rowIN as int32, fromGRID As clsGrid, toGRID As clsGrid)
    '    Dim strROW As String
    '    Dim objWELL As clsWELL
    '    Dim strUWI As String
    '    Dim rowIDX as int32
    '    '
    '    '---Transfer one row from files grid to processing grid
    '    '
    '    toGRID.AddRow(fromGRID.GetRow(rowIN), 0)
    '    toGRID.SetRowHeight(fromGRID.GetRowHeight(rowIN))

    'End Sub

    'Public Sub UnHiLight(rowCURR as int32, rowPREV as int32, fxgIN As MSHFlexGrid)
    '    Dim ii as int32

    '    If rowPREV > 0 Then
    '        fxgIN.Row = rowPREV
    '        For ii = fxgIN.Cols - 1 To 1 Step -1
    '            fxgIN.Col = ii
    '            fxgIN.CellBackColor = bacCOLOR
    '        Next ii
    '        fxgIN.Row = rowCURR
    '    End If

    'End Sub

    'Public Sub HiLight(fxgIN As MSHFlexGrid)
    '    Dim ii as int32

    '    For ii = 6 To 1 Step -1
    '        fxgIN.Col = ii
    '        fxgIN.CellBackColor = selCOLOR
    '    Next ii

    'End Sub

    Public Sub SelectAll(txbIN As TextBox)
        txbIN.SelectAll()
    End Sub
    '
    '---Return legal DOS filename by removing illegal characters
    '
    Public Function FixName(fnameIN As String) As String
        Dim strTemp As String

        strTemp = fnameIN
        strTemp = Replace(strTemp, "<", "")
        strTemp = Replace(strTemp, ">", "")
        strTemp = Replace(strTemp, ":", "")
        strTemp = Replace(strTemp, """", "")
        strTemp = Replace(strTemp, "/", "")
        strTemp = Replace(strTemp, "\", "")
        strTemp = Replace(strTemp, "|", "")
        strTemp = Replace(strTemp, "?", "")
        strTemp = Replace(strTemp, "*", "")

        FixName = strTemp
    End Function

    Public Function xPath(pathIN As String) As String
        Dim strBUFF As String
        xPath = ""
        If pathIN.Length > 0 Then
            strBUFF = Trim(My.Computer.FileSystem.GetParentPath(pathIN))

            If Right(strBUFF, 1) <> "\" Then strBUFF = strBUFF & "\"
            xPath = strBUFF
        End If
    End Function

    Public Function xFile(pathIN As String) As String
        xFile = ""
        If pathIN.Length > 0 Then
            xFile = Trim(My.Computer.FileSystem.GetName(pathIN))
        End If
    End Function

    Function EncryptValue(valueIN As Object) As String
        Dim temp As String
        Dim PwdChr As Integer
        Dim EncryptKey As Integer

        EncryptKey = Int(Math.Sqrt(Len(valueIN) * 81)) + 23
        temp = ""
        For PwdChr = 1 To Len(valueIN)
            temp = temp + Chr(Asc(Mid(valueIN, PwdChr, 1)) Xor EncryptKey)
        Next PwdChr

        EncryptValue = temp
    End Function
    '
    '---Produce CSV index from well list
    '
    '    Public Sub CSVIndex(gridIN As clsGrid, fileIN As String)
    '        Dim objSYS As New FileSystemObject
    '        Dim ii as int32
    '        Dim objWELL As clsWELL
    '        Dim outBUFF As String
    '        Dim objFILE As TextStream
    '        Dim strCOMPANY As String
    '        Dim tmpBUFF As String
    '        '
    '        '---Get Company from registry
    '        '
    '        strCOMPANY = GetKeyValue(HKEY_LOCAL_MACHINE, _
    '                   "Software\Analytics\lasUtilities", "Company")
    '        If strCOMPANY = "" Then strCOMPANY = "Company Name"
    '        '
    '        '---Output column header
    '        '
    '        objFILE = objSYS.CreateTextFile(fileIN, True)
    '        objFILE.WriteLine "APINumber,Operator,Well,County,Min Depth,Max Depth," & _
    '                          "Log Names,Curve Names,Origin,Data Type"
    '        '
    '        '---Index each well
    '        '
    '        For ii = 1 To gridIN.TotalRows
    '            objWELL = gridIN.WellObject(ii)
    '            outBUFF = ""

    '            outBUFF = """" & API14(objWELL.Item("API")) & """"
    '            outBUFF = outBUFF & ",""" & objWELL.Item("OPER") & """"
    '            outBUFF = outBUFF & ",""" & objWELL.Item("WELL") & " " & objWELL.Item("WNUM") & """"
    '            outBUFF = outBUFF & ",""" & objWELL.Item("CNTY") & """"
    '            outBUFF = outBUFF & "," & objWELL.Item("STRT")
    '            outBUFF = outBUFF & "," & objWELL.Item("STOP")
    '            outBUFF = outBUFF & ","
    '            '
    '            '---Append curve names (ignore DEPT)
    '            '
    '            tmpBUFF = Replace(objWELL.CurveNames, ",", " ")
    '            outBUFF = outBUFF & ",""" & Mid(tmpBUFF, InStr(tmpBUFF, " ") + 1) & """"
    '            outBUFF = outBUFF & ",""" & strCOMPANY & """"
    '            outBUFF = outBUFF & ",LAS"

    '            objFILE.WriteLine outBUFF
    '        Next ii

    '        objFILE.Close()
    '        objFILE = Nothing
    '        objSYS = Nothing

    '    End Sub
    '    '
    '    '---Produce CSV index from database file
    '    '
    '    Public Function CSVdbIndex(fileIN As String) As Boolean
    '        Dim objSYS As New FileSystemObject
    '        Dim iWELL as int32
    '        Dim iCRV as int32
    '        Dim objWELL As clsWELL
    '        Dim outBUFF As String
    '        Dim objFILE As TextStream
    '        Dim objDB As New clsLasDBIO
    '        Dim strBUFF As String
    '        Dim rsWELL As ADODB.Recordset
    '        Dim rsCRV As ADODB.Recordset
    '        Dim crvBUFF As String
    '        Dim strCOMPANY As String
    '        '
    '        '---Connect to DB
    '        '
    '        CSVdbIndex = False
    '        strBUFF = objDB.OpenDB(fileIN)
    '        If strBUFF <> "OK" Then
    '            ErrMSG(strBUFF, "Open failure")
    '            objDB = Nothing
    '            Exit Function
    '        End If
    '        '
    '        '---Get Company from registry
    '        '
    '        strCOMPANY = GetKeyValue(HKEY_LOCAL_MACHINE, _
    '                   "Software\Analytics\lasUtilities", "Company")
    '        If strCOMPANY = "" Then strCOMPANY = "Company Name"
    '        '
    '        '---Output column header
    '        '
    '        On Error GoTo FileBusy
    '        fileIN = Replace(fileIN, ".mdb", ".csv")
    '        objFILE = objSYS.CreateTextFile(fileIN, True)

    '        On Error GoTo 0
    '        objFILE.WriteLine "APINumber,Operator,Well,County,Min Depth,Max Depth," & _
    '                          "Log Names,Curve Names,Origin,Data Type"
    '        '
    '        '---Index each well
    '        '
    '        rsWELL = objDB.GetWellIDX
    '        For iWELL = 1 To rsWELL.RecordCount
    '            outBUFF = ""

    '            outBUFF = """" & API14(rsWELL!API) & """"
    '            outBUFF = outBUFF & ",""" & rsWELL!OPER & """"
    '            outBUFF = outBUFF & ",""" & rsWELL!Wellname & " " & rsWELL!WellNbr & """"
    '            outBUFF = outBUFF & ",""" & rsWELL!CNTY & """"
    '            outBUFF = outBUFF & "," & rsWELL!STRTD
    '            outBUFF = outBUFF & "," & rsWELL!STOPD
    '            outBUFF = outBUFF & ","
    '            '
    '            '---Get curve names (ignore DEPT)
    '            '
    '            rsCRV = objDB.GetCrvIDX(rsWELL!WellID)
    '            crvBUFF = ""
    '            For iCRV = 1 To rsCRV.RecordCount
    '                crvBUFF = crvBUFF & rsCRV!Mnem & " "
    '                rsCRV.MoveNext()
    '            Next iCRV
    '            rsCRV.Close()

    '            outBUFF = outBUFF & ",""" & crvBUFF & """"
    '            outBUFF = outBUFF & ",""" & strCOMPANY & """"
    '            outBUFF = outBUFF & ",LAS"

    '            objFILE.WriteLine outBUFF
    '            rsWELL.MoveNext()
    '        Next iWELL

    '        objFILE.Close()
    '        CSVdbIndex = True
    '        objFILE = Nothing
    '        objSYS = Nothing
    '        rsWELL = Nothing
    '        rsCRV = Nothing
    '        Exit Function

    'FileBusy:
    '        ErrMSG("""" & fileIN & """ already open!", "Index Aborted")
    '    End Function

    Public Function API14(apiIN As String) As String
        '
        '---Abort if API is already less or equal to 14
        '
        API14 = apiIN
        If Len(apiIN) <= 14 Then Exit Function
        '
        '---If len greater than 14, trim off country code
        '
        API14 = Right(apiIN, 14)

    End Function

    'Public Sub unloadControl(ctlIN As Object)
    '    Dim ii as int32

    '    For ii = 1 To ctlIN.UBound
    '        On Error Resume Next
    '        Unload ctlIN(ii)
    '    Next ii
    'End Sub
    '
    '---Copy combobox
    '
    'Public Sub CopyCBX(cbxIN As ComboBox, cbxOUT As ComboBox, valueIN as int32)
    '    Dim ii as int32
    '    Dim SaveItem as int32

    '    SaveItem = 0
    '    For ii = 0 To cbxIN.ListCount - 1
    '        cbxOUT.AddItem cbxIN.List(ii)
    '        cbxOUT.ItemData(ii) = cbxIN.ItemData(ii)

    '        If cbxOUT.ItemData(ii) = valueIN Then SaveItem = ii
    '    Next ii
    '    cbxOUT.ListIndex = SaveItem

    'End Sub
    '
    '---Copy imagecombo
    '
    'Public Sub CopyICB(cbxIN As ImageCombo, cbxOUT As ImageCombo, valueIN as int32)
    '    Dim ii as int32
    '    Dim SaveItem as int32

    '    SaveItem = 0
    '    For ii = 1 To cbxIN.ComboItems.Count
    '        cbxOUT.ComboItems.Add, cbxIN.ComboItems(ii).Key, cbxIN.ComboItems(ii).Text, _
    '                                cbxIN.ComboItems(ii).Image

    '        If cbxOUT.ComboItems(ii).Key = "S" & valueIN Then SaveItem = ii
    '    Next ii
    '    cbxOUT.ComboItems(SaveItem).Selected = True

    'End Sub

    'Public Sub fxgControl(fxgIN As MSHFlexGrid, rowIN as int32, colIN as int32, _
    '                      ctrlIN As Control)
    '    With fxgIN
    '        .Row = rowIN
    '        .Col = colIN
    '        ctrlIN.Move.Left(+.CellLeft, .Top + .CellTop, .CellWidth - 10)
    '        ctrlIN.Visible = True
    '        ctrlIN.ZOrder()
    '        ctrlIN.SetFocus()
    '    End With
    'End Sub

    '    int i = aView.CurrentRow.Index + 1;
    '    aView.CurrentCell = aView.Rows[i].Cells[0];
    '
    '---Position desired control over top of specified grid cell
    '
    'Public Sub fxgControl(fxgIN As DataGridView, rowIN As Integer, colIN As Integer, _
    '                      ctrlIN As Control)

    '    fxgIN.CurrentCell = fxgIN(rowIN, colIN)

    '    With fxgIN

    '        ctrlIN.Move .Left + .CellLeft, .Top + .CellTop, .CellWidth - 10)

    '        ctrlIN.Left = fxgIN.CurrentCell.
    '    End With

    '    ctrlIN.Visible = True
    '    ctrlIN.BringToFront()
    '    ctrlIN.Focus()
    'End Sub

    Public Function Log10(valueIN As Single) As Single
        Log10 = 0
        If valueIN > 0 Then Log10 = Math.Log10(valueIN)

        '        If valueIN > 0 Then Log10 = Log(valueIN) / Log(10.0#)
    End Function

    Public Function ValidateNBR(nbrIN As String) As Boolean
        Dim temp As Single

        Try
            If Len(nbrIN) = 0 Then nbrIN = 0
            temp = nbrIN
            ValidateNBR = True

        Catch ex As Exception
            ValidateNBR = False
        End Try

    End Function
    '
    '---Scan combox list for match and return itemdata
    '
    Public Function FindCBXItemData(cbxIN As ComboBox, textIN As String) As int32
        Dim ii As Integer

        Try
            ii = cbxIN.FindStringExact(textIN)
            FindCBXItemData = cbxIN.SelectedValue

        Catch ex As Exception
            FindCBXItemData = -1
        End Try


        'For ii = 0 To cbxIN.ListCount - 1
        '    cbxIN.ListIndex = ii
        '    If cbxIN.Text = textIN Then
        '        FindCBXItemData = cbxIN.ItemData(ii)
        '        Exit Function
        '    End If
        'Next ii
    End Function
    '
    '---Scan combox itemdata list for match and return index
    '
    Public Function FindCBXIndex(cbxIN As ComboBox, itemDataIN As int32) As Integer
        Dim ii As Integer

        FindCBXIndex = 0
        For ii = 0 To cbxIN.Items.Count - 1
            cbxIN.SelectedIndex = ii

            If cbxIN.SelectedValue = itemDataIN Then
                FindCBXIndex = ii
                Exit Function
            End If
        Next ii
    End Function
    '
    '---Scan combox itemdata list for match and return text
    '
    Public Function FindCBXText(cbxIN As ComboBox, itemDataIN As int32) As String
        Dim ii As Integer

        cbxIN.SelectedIndex = 0
        FindCBXText = cbxIN.SelectedText

        For ii = 0 To cbxIN.Items.Count - 1
            cbxIN.SelectedIndex = ii

            If cbxIN.SelectedValue = itemDataIN Then
                FindCBXText = cbxIN.SelectedText
                Exit Function
            End If

        Next ii
    End Function
    ''
    ''---Shell using file extension
    ''
    'Public Sub RunAssociateFile(ByVal strDocName As String)
    '    '
    '    '---From VBcode.com
    '    '
    '    Dim Scr_hDC As int32
    '    Dim rCode As int32

    '    Scr_hDC = GetDesktopWindow()
    '    rCode = ShellExecute(Scr_hDC, "Open", strDocName, "", "C:\", SW_SHOWNORMAL)
    '    '
    '    '---Check return code
    '    '
    '    If rCode <= 32 Then ErrMSG("Error opening """ & strDocName & """!  " & _
    '       "No installed application available to open this file.", "Launch failure")
    'End Sub
  

End Module
