VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsCSV"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private objFSO As FileSystemObject       'System I/O object
Private objFILE As TextStream            'File object

Private pvtFileName As String            'CSV file name

Private pvtIncludeOil As Boolean         'Include OIL properties in file
Private pvtIncludeGAS As Boolean         'Include GAS properties in file
Private pvtIncludeWAT As Boolean         'Include WATER properties in file
Private pvtIncludeROCK As Boolean        'Include ROCK properties in file

Private Sub Class_Initialize()
  Set objFSO = New FileSystemObject
  FileName = "p3.csv"
  IncludeOIL = False
  IncludeGAS = False
  IncludeWAT = False
  IncludeROCK = False
End Sub

Private Sub Class_Terminate()
  On Error Resume Next
  Set objFILE = Nothing
  Set objFSO = Nothing
End Sub
'
'============================== Properties ====================================
'
'
'---File name
'
Public Property Get FileName() As String
  FileName = pvtFileName
End Property

Public Property Let FileName(ByVal vNewValue As String)
  pvtFileName = vNewValue
End Property
'
'---CSV export inclusions
'
Public Property Get IncludeOIL() As Boolean
  IncludeOIL = pvtIncludeOil
End Property

Public Property Let IncludeOIL(ByVal vNewValue As Boolean)
  pvtIncludeOil = vNewValue
End Property

Public Property Get IncludeGAS() As Boolean
  IncludeGAS = pvtIncludeGAS
End Property

Public Property Let IncludeGAS(ByVal vNewValue As Boolean)
  pvtIncludeGAS = vNewValue
End Property

Public Property Get IncludeWAT() As Boolean
  IncludeWAT = pvtIncludeWAT
End Property

Public Property Let IncludeWAT(ByVal vNewValue As Boolean)
  pvtIncludeWAT = vNewValue
End Property

Public Property Get IncludeROCK() As Boolean
  IncludeROCK = pvtIncludeROCK
End Property

Public Property Let IncludeROCK(ByVal vNewValue As Boolean)
  pvtIncludeROCK = vNewValue
End Property
'
'============================== Methods ====================================
'
'
'---CSV Export method
'
Public Sub Execute()
  Dim ii As Integer
  Dim strVAL As String
  Dim strLBL As String
'
'---Open new report file
'
  Set objFILE = objFSO.CreateTextFile(FileName, True)
'
'---Input data
'
  If IncludeOIL Or IncludeGAS Or IncludeWAT Then
    objFILE.WriteLine ("Std Pressure (psia):," & Format(objFluid.StdP, "0.0"))
    objFILE.WriteLine ("Std Temp (F):," & Format(objFluid.StdTf, "0.0"))
    objFILE.WriteLine ("Reservoir Temp (F):," & Format(objFluid.ResTf, "0.0"))
  End If
'
'---Oil Properties
'
  If IncludeOIL Then
    
    objFILE.WriteBlankLines (1)
    objFILE.WriteLine ("Oil Properties:")
    objFILE.WriteBlankLines (1)
    
    objFILE.WriteLine ("API Gravity:," & objOil.API)
    objFILE.WriteLine ("Specific Gravity:," & objOil.OilSG)
    objFILE.WriteLine ("Separator Gas Gravity:," & objOil.SepGG)
    objFILE.WriteLine ("Separator Pressure (psia):," & objOil.SepP)
    objFILE.WriteLine ("Separator Temp (F):," & objOil.SepTf)
    
    objFILE.WriteLine ("Bubble Pt Pres (psia):," & objUtil.Nbr2Str(objOil.Pbp, 10, 1))
    objFILE.WriteLine ("Compressibility @ Pbp:," & _
                       objUtil.Nbr2Str(objOil.GetCO(objPrs.BPPi), 10, 7))
    objFILE.WriteLine ("StockTank Oil Density (lb/scf):," & _
                       objUtil.Nbr2Str(objOil.STDenOil, 10, 3))
    objFILE.WriteLine ("StockTank Gas Density (lb/scf):," & _
                       objUtil.Nbr2Str(objOil.STDenGas, 10, 5))
    objFILE.WriteLine ("Initial GOR-Separator (scf/stb):," & _
                       objUtil.Nbr2Str(objOil.RSISep, 10, 1))
    objFILE.WriteLine ("StockTank (scf/stb):," & _
                       objUtil.Nbr2Str(objOil.RSITank, 10, 1))
    objFILE.WriteLine ("Total (scf/stb):," & objUtil.Nbr2Str(objOil.RSI, 10, 1))
    
    objFILE.WriteBlankLines (1)
    objFILE.WriteLine ("Undersaturated properties:")
    objFILE.WriteBlankLines (1)
    objFILE.WriteLine (",,Volume,Dissolved")
    objFILE.WriteLine (",Pressure,Factor,GOR,Viscosity,Density")
    objFILE.WriteLine (",(psia),(rb/stb),(scf/stb),(cp),(lb/ft3)")
    
    For ii = 1 To objPrs.NPRSo
      objFILE.Write ("," & objUtil.Nbr2Str(objPrs.GetPRSo(ii), 11, 1) & ",")
      objFILE.Write (objUtil.Nbr2Str(objOil.GetBO(ii), 12, 4) & ",")
      objFILE.Write (objUtil.Nbr2Str(objOil.GetRSO(ii), 11, 1) & ",")
      objFILE.Write (objUtil.Nbr2Str(objOil.GetMUO(ii), 12, 3) & ",")
      objFILE.WriteLine (objUtil.Nbr2Str(objOil.GetRHOO(ii), 13, 3))
    Next ii

    objFILE.WriteBlankLines (2)
    objFILE.WriteLine ("Saturated properties:")
    objFILE.WriteBlankLines (1)
    objFILE.WriteLine (",,Volume,Dissolved")
    objFILE.WriteLine (",Pressure,Factor,GOR,Viscosity,Density")
    objFILE.WriteLine (",(psia),(rb/stb),(scf/stb),(cp),(lb/ft3)")

    For ii = 1 To objPrs.NPRSo
      objFILE.Write ("," & objUtil.Nbr2Str(objPrs.GetPRSo(ii), 11, 1) & ",")
      objFILE.Write (objUtil.Nbr2Str(objOil.GetBOS(ii), 12, 4) & ",")
      objFILE.Write (objUtil.Nbr2Str(objOil.GetRSOS(ii), 11, 1) & ",")
      objFILE.Write (objUtil.Nbr2Str(objOil.GetMUOS(ii), 12, 3) & ",")
      objFILE.WriteLine (objUtil.Nbr2Str(objOil.GetRHOOS(ii), 13, 3))
    Next ii
  End If
'
'---Gas Properties
'
  If IncludeOIL Or IncludeGAS Then

    objFILE.WriteBlankLines (1)
    objFILE.WriteLine ("Gas Properties:")
    objFILE.WriteBlankLines (1)

    If objGas.GasEntry = "G" Then
      objFILE.WriteLine ("Gas Gravity:," & _
                          objUtil.Nbr2Str(objGas.GasGrav, 10, 3))
      objFILE.WriteLine ("Nitrogen (mole frac):," & _
                          objUtil.Nbr2Str(objGas.mfN, 10, 3))
      objFILE.WriteLine ("Carbon Dioxide (mole frac):," & _
                          objUtil.Nbr2Str(objGas.mfCO2, 10, 3))
      objFILE.WriteLine ("Hydrogen Sulfide (mole frac):," & _
                          objUtil.Nbr2Str(objGas.mfH2S, 10, 3))
    Else
      objFILE.WriteLine ("Methane:," & _
                          objUtil.Nbr2Str(objGas.GetGC(1), 6, 4))
      objFILE.WriteLine ("Ethane:," & _
                          objUtil.Nbr2Str(objGas.GetGC(2), 6, 4))
      objFILE.WriteLine ("Propane:," & _
                          objUtil.Nbr2Str(objGas.GetGC(3), 6, 4))
      objFILE.WriteLine ("i-Butane:," & _
                          objUtil.Nbr2Str(objGas.GetGC(4), 6, 4))
      objFILE.WriteLine ("n-Butane:," & _
                          objUtil.Nbr2Str(objGas.GetGC(5), 6, 4))
      objFILE.WriteLine ("i-Pentane:," & _
                          objUtil.Nbr2Str(objGas.GetGC(6), 6, 4))
      objFILE.WriteLine ("n-Pentane:," & _
                          objUtil.Nbr2Str(objGas.GetGC(7), 6, 4))
      objFILE.WriteLine ("Hexane:," & _
                          objUtil.Nbr2Str(objGas.GetGC(8), 6, 4))
      objFILE.WriteLine ("Heptane:," & _
                          objUtil.Nbr2Str(objGas.GetGC(9), 6, 4))
      objFILE.WriteLine ("Octane:," & _
                          objUtil.Nbr2Str(objGas.GetGC(10), 6, 4))
      objFILE.WriteLine ("Nonane:," & _
                          objUtil.Nbr2Str(objGas.GetGC(11), 6, 4))
      objFILE.WriteLine ("Decane:," & _
                          objUtil.Nbr2Str(objGas.GetGC(12), 6, 4))
      objFILE.WriteLine ("Nitrogen:," & _
                          objUtil.Nbr2Str(objGas.GetGC(13), 6, 4))
      objFILE.WriteLine ("Carbon Dioxide:," & _
                          objUtil.Nbr2Str(objGas.GetGC(14), 6, 4))
      objFILE.WriteLine ("Hydrogen Sulfide:," & _
                          objUtil.Nbr2Str(objGas.GetGC(15), 6, 4))
    End If

    objFILE.WriteBlankLines (1)
    objFILE.WriteLine ("Critical Pressure (psia):," & _
                        objUtil.Nbr2Str(objGas.pC, 10, 2))
    objFILE.WriteLine ("Critical Temperature (R):," & _
                        objUtil.Nbr2Str(objGas.tC, 10, 2))
    objFILE.WriteLine ("Pseudo-Reduced Temperature:," & _
                        objUtil.Nbr2Str(objGas.PTR, 10, 3))

    objFILE.WriteLine ("StockTank Gas Density (lb/scf):," & _
                        objUtil.Nbr2Str(objGas.STDenGas, 10, 5))

    objFILE.WriteBlankLines (1)
    objFILE.WriteLine (",,Pseudo-Reduced,Gas (Z)")
    objFILE.WriteLine (",Pressure,Pressure,Deviation,P/Z")
    objFILE.WriteLine (",(psia),,Factor,(psia)")

    For ii = 1 To objPrs.NPRSo
      objFILE.Write ("," & objUtil.Nbr2Str(objPrs.GetPRSo(ii), 11, 1) & ",")
      objFILE.Write (objUtil.Nbr2Str(objGas.GetPPR(ii), 12, 3) & ",")
      objFILE.Write (objUtil.Nbr2Str(objGas.GetZ(ii), 13, 3) & ",")
      objFILE.WriteLine (objUtil.Nbr2Str(objGas.GetPZ(ii), 13, 1))
    Next ii

    objFILE.WriteBlankLines (1)
    objFILE.WriteLine (",,Gas Volume,,,,Real Gas Potential")
    objFILE.WriteLine (",Pressure,Factor,Viscosity,Compressibility,Density,m(p)/1E06")
    objFILE.WriteLine (",(psia),(rcf/scf),(cp),(psi-1),(lb/rcf),(psia^2/cp)")

    For ii = 1 To objPrs.NPRSo
      objFILE.Write ("," & objUtil.Nbr2Str(objPrs.GetPRSo(ii), 11, 1) & ",")
      objFILE.Write (objUtil.Nbr2Str(objGas.GetBG(ii), 12, 5) & ",")
      objFILE.Write (objUtil.Nbr2Str(objGas.GetMUG(ii), 11, 4) & ",")
      objFILE.Write (objUtil.Nbr2Str(objGas.GetCG(ii), 12, 7) & ",")
      objFILE.Write (objUtil.Nbr2Str(objGas.GetRHOG(ii), 13, 4) & ",")
      objFILE.WriteLine (objUtil.Nbr2Str(objGas.GetRMP(ii), 15, 3))
    Next ii
  End If
'
'---Water Properties
'
  If IncludeWAT Then

    objFILE.WriteBlankLines (1)
    objFILE.WriteLine ("Water Properties:")
    objFILE.WriteBlankLines (1)

    objFILE.WriteLine ("Weight % Solids:," & objUtil.Nbr2Str(objWat.PER, 10, 1))
    objFILE.WriteLine ("Dissolved Solids (ppm):," & _
                        objUtil.Nbr2Str(objWat.PPM, 10, 0))
    objFILE.WriteLine ("StockTank Density (lb/scf):," & _
                        objUtil.Nbr2Str(objWat.STDenWat, 10, 3))

    objFILE.WriteBlankLines (1)
    objFILE.WriteLine (",,Volume,Dissolved,")
    objFILE.WriteLine (",Pressure,Factor,GOR,Viscosity,Compressibility,Density")
    objFILE.WriteLine (",(psia),(rb/stb),(scf/stb),(cp),(psi-1),(lb/rcf)")

    For ii = 1 To objPrs.NPRSo
      objFILE.Write ("," & objUtil.Nbr2Str(objPrs.GetPRSo(ii), 11, 1) & ",")
      objFILE.Write (objUtil.Nbr2Str(objWat.GetBW(ii), 12, 5) & ",")
      objFILE.Write (objUtil.Nbr2Str(objWat.GetRSW(ii), 11, 1) & ",")
      objFILE.Write (objUtil.Nbr2Str(objWat.GetMUW(ii), 12, 3) & ",")
      objFILE.Write (objUtil.Nbr2Str(objWat.GetCW(ii), 13, 7) & ",")
      objFILE.WriteLine (objUtil.Nbr2Str(objWat.GetRHOW(ii), 13, 3))
    Next ii
  End If
'
'---Rock Properties
'
  If IncludeROCK Then

    objFILE.WriteBlankLines (1)
    objFILE.WriteLine ("Rock Properties:")
    objFILE.WriteBlankLines (1)

    strVAL = "Oil/Water System"
    If objRock.Fluids = 1 Then strVAL = "Gas/Oil System"
    objFILE.WriteLine ("Fluids:," & strVAL)

    strVAL = "Drainage"
    If objRock.Displace = 1 Then strVAL = "Imbibition"
    objFILE.WriteLine ("Displacement:," & strVAL)

    strVAL = "Sandstone"
    If objRock.Lith = 1 Then strVAL = "Limestone"
    objFILE.WriteLine ("Lithology:," & strVAL)
    
    objFILE.WriteLine ("Connate Water:," & _
                        objUtil.Nbr2Str(objRock.SWC, 8, 2))

    If objRock.Fluids = 0 Then                           'Oil/Water system
      strVAL = "Water Wet"
      If objRock.Wet = 1 Then strVAL = "Oil Wet"
      objFILE.WriteLine ("Wettability:," & strVAL)
      
      objFILE.WriteLine ("Residual Oil to Water:," & _
                          objUtil.Nbr2Str(objRock.SORW, 8, 2))
    End If
    
    If objRock.Fluids = 1 Then                           'Gas/Oil system
      strLBL = "Residual Oil to Gas:,"
      strVAL = objUtil.Nbr2Str(objRock.SWC, 8, 2)
      objFILE.WriteLine (strLBL & strVAL)
      
      strLBL = "Critical Gas:,"
      strVAL = objUtil.Nbr2Str(objRock.SGCrit, 8, 2)
      objFILE.WriteLine (strLBL & strVAL)
    End If
    
    strLBL = "Correlation Type:,"
    strVAL = "Corey"
    If objRock.CORR = 1 Then strVAL = "Honarpour"
    objFILE.WriteLine (strLBL & strVAL)

    If objRock.CORR = 0 Then
      strLBL = "K Exponent:,"
      strVAL = objUtil.Nbr2Str(objRock.CoreyK, 5, 2)
      objFILE.WriteLine (strLBL & strVAL)
      
      strLBL = "N Exponent:,"
      strVAL = objUtil.Nbr2Str(objRock.CoreyN, 5, 2)
      objFILE.WriteLine (strLBL & strVAL)
    Else
      strLBL = "Porosity (frac):,"
      strVAL = objUtil.Nbr2Str(objRock.HRPoro, 6, 2)
      objFILE.WriteLine (strLBL & strVAL)
      
      strLBL = "Air Perm (md):,"
      strVAL = objUtil.Nbr2Str(objRock.HRAir, 6, 2)
      objFILE.WriteLine (strLBL & strVAL)
      
      strLBL = "Krg @Sorg:,"
      strVAL = objUtil.Nbr2Str(objRock.HRKrg, 6, 2)
      objFILE.WriteLine (strLBL & strVAL)
    End If

    If objRock.Fluids = 0 Then                           'Oil/Water system
      objFILE.WriteBlankLines (1)
      objFILE.WriteLine (",Saturations,,Relative Permeability")
      objFILE.WriteLine (",Water,Oil,Water,Oil")
      
      For ii = 1 To objRock.NWet
        strVAL = objUtil.Nbr2Str(objRock.GetSWet(ii), 11, 2)
        objFILE.Write ("," & strVAL & ",")

        strVAL = objUtil.Nbr2Str(objRock.GetSNWet(ii), 12, 2)
        objFILE.Write (strVAL & ",")
  
        strVAL = objUtil.Nbr2Str(objRock.GetKRWat(ii), 12, 4)
        objFILE.Write (strVAL & ",")

        strVAL = objUtil.Nbr2Str(objRock.GetKROil(ii), 12, 4)
        objFILE.WriteLine (strVAL)
      Next ii
    End If

    If objRock.Fluids = 1 Then                           'Gas/Oil system
      objFILE.WriteBlankLines (1)
      objFILE.WriteLine (",Saturations,,,Relative Permeability")
      objFILE.WriteLine (",Gas,Soil,Swater,Gas,Oil")
      
      For ii = 1 To objRock.NWet
        strVAL = objUtil.Nbr2Str(objRock.GetSNWet(ii), 11, 4)
        objFILE.Write ("," & strVAL & ",")

        strVAL = objUtil.Nbr2Str(objRock.GetSWet(ii) - objRock.SWC, 12, 2)
        objFILE.Write (strVAL & ",")
  
        strVAL = objUtil.Nbr2Str(objRock.SWC, 12, 2)
        objFILE.Write (strVAL & ",")

        strVAL = objUtil.Nbr2Str(objRock.GetKRGas(ii), 12, 4)
        objFILE.Write (strVAL & ",")

        strVAL = objUtil.Nbr2Str(objRock.GetKROil(ii), 12, 4)
        objFILE.WriteLine (strVAL)
      Next ii
    End If
  End If
  
  objFILE.Close
  Set objFILE = Nothing
  
  Call InfoMSG("CSV output complete!", "File: " & FileName)
End Sub
