VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsECL"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private objFSO As FileSystemObject       'System I/O object
Private objFILE As TextStream            'File object

Private pvtPVDO As Boolean               'Output PVDO - Oil with no gas
Private pvtPVTO As Boolean               'Output PVTO - Oil with gas
Private pvtPVDG As Boolean               'Output PVDG - Gas reservoir
Private pvtPVTW As Boolean               'Output PVTW - Water
Private pvtDENS As Boolean               'Output DENSITY
Private pvtSWOF As Boolean               'Output SWOF - Water/Oil rock
Private pvtSGOF As Boolean               'Output SGOF - Gas/Oil rock

Private pvtFileName As String            'Default Output file name
Private pvtPVDOFile As String            'ECL PVDO file name
Private pvtPVTOFile As String            'ECL PVTO file name
Private pvtPVDGFile As String            'ECL PVDG file name
Private pvtPVTWFile As String            'ECL PVTW file name
Private pvtDENSFile As String            'ECL DENSITY file name
Private pvtSWOFFile As String            'ECL SWOF file name
Private pvtSGOFFile As String            'ECL SGOF file name

Private Sub Class_Initialize()
  Set objFSO = New FileSystemObject
  FileName = "Eclipse"
  PVDO = False
  PVTO = False
  PVDG = False
  PVTW = False
  DENS = False
  SWOF = False
  SGOF = False
End Sub

Private Sub Class_Terminate()
  On Error Resume Next
  Set objFILE = Nothing
  Set objFSO = Nothing
End Sub
'
'============================== Properties ====================================
'
'
'---Default File name
'
Public Property Get FileName() As String
  FileName = pvtFileName
End Property

Public Property Let FileName(ByVal vNewValue As String)
  pvtFileName = vNewValue
  PVDOFile = pvtFileName & ".pvdo"
  PVTOFile = pvtFileName & ".pvto"
  PVDGFile = pvtFileName & ".pvdg"
  PVTWFile = pvtFileName & ".pvtw"
  DENSFile = pvtFileName & ".dens"
  SWOFFile = pvtFileName & ".swof"
  SGOFFile = pvtFileName & ".sgof"
End Property
'
'---PVDO File name
'
Public Property Get PVDOFile() As String
  PVDOFile = pvtPVDOFile
End Property

Public Property Let PVDOFile(ByVal vNewValue As String)
  pvtPVDOFile = vNewValue
End Property
'
'---PVTO File name
'
Public Property Get PVTOFile() As String
  PVTOFile = pvtPVTOFile
End Property

Public Property Let PVTOFile(ByVal vNewValue As String)
  pvtPVTOFile = vNewValue
End Property
'
'---PVDG File name
'
Public Property Get PVDGFile() As String
  PVDGFile = pvtPVDGFile
End Property

Public Property Let PVDGFile(ByVal vNewValue As String)
  pvtPVDGFile = vNewValue
End Property
'
'---PVTW File name
'
Public Property Get PVTWFile() As String
  PVTWFile = pvtPVTWFile
End Property

Public Property Let PVTWFile(ByVal vNewValue As String)
  pvtPVTWFile = vNewValue
End Property
'
'---DENSITY File name
'
Public Property Get DENSFile() As String
  DENSFile = pvtDENSFile
End Property

Public Property Let DENSFile(ByVal vNewValue As String)
  pvtDENSFile = vNewValue
End Property
'
'---SWOF File name
'
Public Property Get SWOFFile() As String
  SWOFFile = pvtSWOFFile
End Property

Public Property Let SWOFFile(ByVal vNewValue As String)
  pvtSWOFFile = vNewValue
End Property
'
'---SGOF File name
'
Public Property Get SGOFFile() As String
  SGOFFile = pvtSGOFFile
End Property

Public Property Let SGOFFile(ByVal vNewValue As String)
  pvtSGOFFile = vNewValue
End Property
'
'---ECL export inclusions
'
Public Property Get PVDO() As Boolean
  PVDO = pvtPVDO
End Property

Public Property Let PVDO(ByVal vNewValue As Boolean)
  pvtPVDO = vNewValue
End Property

Public Property Get PVTO() As Boolean
  PVTO = pvtPVTO
End Property

Public Property Let PVTO(ByVal vNewValue As Boolean)
  pvtPVTO = vNewValue
End Property

Public Property Get PVDG() As Boolean
  PVDG = pvtPVDG
End Property

Public Property Let PVDG(ByVal vNewValue As Boolean)
  pvtPVDG = vNewValue
End Property

Public Property Get PVTW() As Boolean
  PVTW = pvtPVTW
End Property

Public Property Let PVTW(ByVal vNewValue As Boolean)
  pvtPVTW = vNewValue
End Property

Public Property Get DENS() As Boolean
  DENS = pvtDENS
End Property

Public Property Let DENS(ByVal vNewValue As Boolean)
  pvtDENS = vNewValue
End Property

Public Property Get SWOF() As Boolean
  SWOF = pvtSWOF
End Property

Public Property Let SWOF(ByVal vNewValue As Boolean)
  pvtSWOF = vNewValue
End Property

Public Property Get SGOF() As Boolean
  SGOF = pvtSGOF
End Property

Public Property Let SGOF(ByVal vNewValue As Boolean)
  pvtSGOF = vNewValue
End Property
'
'============================== Methods ====================================
'
'
'---ECL Export method
'
Public Sub Execute()
  Dim ii As Integer, maxPi As Integer, iiREF As Integer
  Dim kk As Integer
  Dim X As Single, Y As Single, A As Single, Z As Single
  Dim fileIDs As String
  Dim DMUWDP As Single
  Dim strVal As String
  Dim strLBL As String
  
  fileIDs = ""
'
'---PVDO - Oil with no gas
'
  If PVDO Then
    fileIDs = "PVDO "
    Set objFILE = objFSO.CreateTextFile(PVDOFile, True)
    objFILE.WriteLine ("PVDO")
    
    objFILE.WriteBlankLines (1)
    objFILE.WriteLine ("-- STOCK TANK OIL DENSITY (LB/SCF) = " & _
                       objUtil.Nbr2Str(objOil.STDenOil, 10, 3))
    objFILE.WriteBlankLines (1)

    objFILE.WriteLine ("--   PRESS(PSIA)    BO(RB/MCF)    MUO(CP)")

    For ii = objPrs.BPPi To 1 Step -1
      objFILE.Write (objUtil.Nbr2Str(objPrs.GetPRSo(ii), 15, 1))
      objFILE.Write (objUtil.Nbr2Str(objOil.GetBO(ii), 14, 4))
      objFILE.WriteLine (objUtil.Nbr2Str(objOil.GetMUO(ii), 11, 3))
    Next ii
    objFILE.WriteLine ("/")
    objFILE.WriteBlankLines (3)

    X = objOil.GetRSO(objPrs.BPPi) / 1000#

    objFILE.WriteLine ("RSCONST")
    objFILE.Write (objUtil.Nbr2Str(X, 12, 3) & objUtil.Nbr2Str(objOil.Pbp, 9, 1) & _
                   "     /")
    objFILE.WriteBlankLines (1)
    
    objFILE.Close
  End If
'
'---PVTO - Oil with dissolved gas
'
  If PVTO Then
    fileIDs = fileIDs & "PVTO "
    Set objFILE = objFSO.CreateTextFile(PVTOFile, True)
    objFILE.WriteLine ("PVTO")
    
    objFILE.WriteBlankLines (1)
    objFILE.WriteLine ("-- STOCK TANK OIL DENSITY (LB/SCF) = " & _
                       objUtil.Nbr2Str(objOil.STDenOil, 10, 3))
    objFILE.WriteBlankLines (1)
    
    objFILE.WriteLine ("--  RSO(MCF/B)   PRESS(PSIA)    BO(RB/MCF)    MUO(CP)")
    
    For ii = objPrs.NPRSo To 1 Step -1
      X = objOil.GetRSOS(ii) / 1000#
      
      objFILE.Write (objUtil.Nbr2Str(X, 14, 3))
      objFILE.Write (objUtil.Nbr2Str(objPrs.GetPRSo(ii), 15, 1))
      objFILE.Write (objUtil.Nbr2Str(objOil.GetBOS(ii), 14, 4))
      objFILE.Write (objUtil.Nbr2Str(objOil.GetMUOS(ii), 11, 3))
'
'---Output undersaturated values at Pbp
'
      If ii = objPrs.BPPi Then
        objFILE.WriteLine (" ")
        For kk = ii - 1 To 1 Step -1
          objFILE.Write (objUtil.Nbr2Str(objPrs.GetPRSo(kk), 29, 1))
          objFILE.Write (objUtil.Nbr2Str(objOil.GetBO(kk), 14, 4))
          objFILE.Write (objUtil.Nbr2Str(objOil.GetMUO(kk), 11, 3))
          If kk > 1 Then
            objFILE.WriteLine (" ")
          End If
        Next kk
      End If
      
      If ii > 1 Then
        objFILE.WriteLine ("   /")
      Else
        objFILE.WriteLine (" ")
      End If
    Next ii
    
    X = objPrs.GetPRSo(1) + 200#
    Y = objOil.GetBOS(1) * Exp(objOil.GetCO(1) * (-200#))
    A = 2.6 * (X ^ 1.187) * Exp(-0.0000898 * X - 11.513)
    Z = objOil.GetMUOS(1) * (X / objPrs.GetPRSo(1)) ^ A

    objFILE.Write (Space(18) & objUtil.Nbr2Str(X, 11, 1))
    objFILE.Write (objUtil.Nbr2Str(Y, 14, 4))
    objFILE.WriteLine (objUtil.Nbr2Str(Z, 11, 3) & "   /")
    objFILE.WriteLine ("/")
    objFILE.WriteBlankLines (1)
    
    objFILE.Close
  End If
'
'---PVDG - Gas reservoir
'
  If PVDG Then
    fileIDs = fileIDs & "PVDG "
    Set objFILE = objFSO.CreateTextFile(PVDGFile, True)
    objFILE.WriteLine ("PVDG")
    
    objFILE.WriteBlankLines (1)
    objFILE.WriteLine ("-- STOCK TANK GAS DENSITY (LB/SCF) = " & _
                       objUtil.Nbr2Str(objGas.STDenGas, 7, 3))
    objFILE.WriteBlankLines (1)
    
    objFILE.WriteLine ("--  PRESSURE(PSIA)   BG(RB/MCF)  MUG(CP)")
    
    For ii = objPrs.NPRSo To 1 Step -1
      X = objGas.GetBG(ii) * 1000# / 5.615
      
      objFILE.Write (objUtil.Nbr2Str(objPrs.GetPRSo(ii), 15, 1))
      objFILE.Write (objUtil.Nbr2Str(X, 15, 5))
      objFILE.WriteLine (objUtil.Nbr2Str(objGas.GetMUG(ii), 9, 4))
    Next ii
    objFILE.WriteLine ("/")
    objFILE.WriteBlankLines (1)
    
    objFILE.Close
  End If
  Set objFILE = Nothing
'
'---PVTW - Water
'
  If PVTW Then
    fileIDs = fileIDs & "PVTW "
    Set objFILE = objFSO.CreateTextFile(PVTWFile, True)
    objFILE.WriteLine ("PVTW")
    
    objFILE.WriteBlankLines (1)
    objFILE.WriteLine ("-- STOCK TANK WATER DENSITY (LB/SCF) = " & _
                       objUtil.Nbr2Str(objWat.STDenWat, 7, 3))
    objFILE.WriteBlankLines (1)

    objFILE.WriteLine ("--  Pref(PSIA)   BWref(RB/STB)   CWref(PSI-1)   MUWref(CP)      DMUWDP")
    
    iiREF = 1
    If objPrs.NPRSo > 2 Then iiREF = Round(objPrs.NPRSo / 2#, 0)
    DMUWDP = 0#
    If iiREF > 1 Then
      DMUWDP = ((objWat.GetMUW(iiREF + 1) - objWat.GetMUW(iiREF - 1)) / _
                (objPrs.GetPRSo(iiREF + 1) - objPrs.GetPRSo(iiREF - 1))) / objWat.GetMUW(iiREF)
    End If
    
    objFILE.Write (objUtil.Nbr2Str(objPrs.GetPRSo(iiREF), 14, 1))
    objFILE.Write (objUtil.Nbr2Str(objWat.GetBW(iiREF), 16, 4))
    objFILE.Write (objUtil.Nbr2Str(objWat.GetCW(iiREF), 15, 7))
    objFILE.Write (objUtil.Nbr2Str(objWat.GetMUW(iiREF), 13, 3))
    objFILE.WriteLine (objUtil.Nbr2Str(DMUWDP, 12, 7) & "    /")
    objFILE.WriteBlankLines (1)
    
    objFILE.Close
  End If
'
'---DENSITY
'
  If DENS Then
    fileIDs = fileIDs & "DENSITY "
    Set objFILE = objFSO.CreateTextFile(DENSFile, True)
    objFILE.WriteLine ("DENSITY")
    
    objFILE.WriteBlankLines (1)

    objFILE.WriteLine ("--  StockTank Oil   StockTank Water   StockTank Gas")
    
    objFILE.Write (objUtil.Nbr2Str(objOil.STDenOil, 17, 3))
    objFILE.Write (objUtil.Nbr2Str(objWat.STDenWat, 18, 3))
    objFILE.WriteLine (objUtil.Nbr2Str(objGas.STDenGas, 16, 3) & "    /")
    objFILE.WriteBlankLines (1)
    
    objFILE.Close
  End If
'
'---SWOF - Water/Oil rock
'
  If SWOF Then
    fileIDs = fileIDs & "SWOF "
    Set objFILE = objFSO.CreateTextFile(SWOFFile, True)
    objFILE.WriteLine ("SWOF")
    
    objFILE.WriteBlankLines (1)
    objFILE.WriteLine ("-- Relative Permeability from Correleations")
    
    strLBL = "-- Fluids: "
    strVal = "Oil/Water System"
    objFILE.WriteLine (strLBL & strVal)
    
    strLBL = "-- Displacement: "
    strVal = "Drainage"
    If objRock.Displace = 1 Then strVal = "Imbibition"
    objFILE.WriteLine (strLBL & strVal)
    
    strLBL = "-- Lithology: "
    strVal = "Sandstone"
    If objRock.Lith = 1 Then strVal = "Limestone"
    objFILE.WriteLine (strLBL & strVal)
      
    strLBL = "-- Connate Water: "
    strVal = objUtil.Nbr2Str(objRock.SWC, 8, 2)
    objFILE.WriteLine (strLBL & strVal)
    
    strLBL = "-- Wettability: "
    strVal = "Water Wet"
    If objRock.Wet = 1 Then strVal = "Oil Wet"
    objFILE.WriteLine (strLBL & strVal)
   
    strLBL = "-- Residual Oil to Water: "
    strVal = objUtil.Nbr2Str(objRock.SORW, 8, 2)
    objFILE.WriteLine (strLBL & strVal)
    
    strLBL = "-- Correlation Type: "
    strVal = "Corey"
    If objRock.CORR = 1 Then strVal = "Honarpour"
    objFILE.WriteLine (strLBL & strVal)

    If objRock.CORR = 0 Then
      strLBL = "-- K Exponent: "
      strVal = objUtil.Nbr2Str(objRock.CoreyK, 5, 2)
      objFILE.WriteLine (strLBL & strVal)
      
      strLBL = "-- N Exponent: "
      strVal = objUtil.Nbr2Str(objRock.CoreyN, 5, 2)
      objFILE.WriteLine (strLBL & strVal)
    Else
      strLBL = "-- Porosity (frac): "
      strVal = objUtil.Nbr2Str(objRock.HRPoro, 6, 2)
      objFILE.WriteLine (strLBL & strVal)
      
      strLBL = "-- Air Perm (md): "
      strVal = objUtil.Nbr2Str(objRock.HRAir, 6, 2)
      objFILE.WriteLine (strLBL & strVal)
      
      strLBL = "-- Krg @Sorg: "
      strVal = objUtil.Nbr2Str(objRock.HRKrg, 6, 2)
      objFILE.WriteLine (strLBL & strVal)
    End If
    
    objFILE.WriteBlankLines (1)
    objFILE.WriteLine ("--      SWAT     KRWAT     KROIL      PCOW")
    
    For ii = 1 To objRock.NWet
      strVal = objUtil.Nbr2Str(objRock.GetSWet(ii), 12, 2)
      objFILE.Write (strVal)

      strVal = objUtil.Nbr2Str(objRock.GetKRWat(ii), 10, 4)
      objFILE.Write (strVal)

      strVal = objUtil.Nbr2Str(objRock.GetKROil(ii), 10, 4)
      objFILE.Write (strVal)
      
      objFILE.WriteLine ("     0.000")
    Next ii
    
    objFILE.WriteLine ("/")
    objFILE.WriteBlankLines (1)
    
    objFILE.Close
  End If
'
'---SGOF - Gas/Oil rock
'
  If SGOF Then
    fileIDs = fileIDs & "SGOF "
    Set objFILE = objFSO.CreateTextFile(SGOFFile, True)
    objFILE.WriteLine ("SGOF")
    
    objFILE.WriteBlankLines (1)
    objFILE.WriteLine ("-- Relative Permeability from Correleations")
    
    strLBL = "-- Fluids: "
    strVal = "Gas/Oil System"
    objFILE.WriteLine (strLBL & strVal)
    
    strLBL = "-- Displacement: "
    strVal = "Drainage"
    If objRock.Displace = 1 Then strVal = "Imbibition"
    objFILE.WriteLine (strLBL & strVal)
    
    strLBL = "-- Lithology: "
    strVal = "Sandstone"
    If objRock.Lith = 1 Then strVal = "Limestone"
    objFILE.WriteLine (strLBL & strVal)
      
    strLBL = "-- Connate Water: "
    strVal = objUtil.Nbr2Str(objRock.SWC, 8, 2)
    objFILE.WriteLine (strLBL & strVal)
    
    strLBL = "-- Residual Oil to Gas: "
    strVal = objUtil.Nbr2Str(objRock.SWC, 8, 2)
    objFILE.WriteLine (strLBL & strVal)
      
    strLBL = "-- Critical Gas: "
    strVal = objUtil.Nbr2Str(objRock.SGCrit, 8, 2)
    objFILE.WriteLine (strLBL & strVal)
    
    strLBL = "-- Correlation Type: "
    strVal = "Corey"
    If objRock.CORR = 1 Then strVal = "Honarpour"
    objFILE.WriteLine (strLBL & strVal)

    If objRock.CORR = 0 Then
      strLBL = "-- K Exponent: "
      strVal = objUtil.Nbr2Str(objRock.CoreyK, 5, 2)
      objFILE.WriteLine (strLBL & strVal)
      
      strLBL = "-- N Exponent: "
      strVal = objUtil.Nbr2Str(objRock.CoreyN, 5, 2)
      objFILE.WriteLine (strLBL & strVal)
    Else
      strLBL = "-- Porosity (frac): "
      strVal = objUtil.Nbr2Str(objRock.HRPoro, 6, 2)
      objFILE.WriteLine (strLBL & strVal)
      
      strLBL = "-- Air Perm (md): "
      strVal = objUtil.Nbr2Str(objRock.HRAir, 6, 2)
      objFILE.WriteLine (strLBL & strVal)
      
      strLBL = "-- Krg @Sorg: "
      strVal = objUtil.Nbr2Str(objRock.HRKrg, 6, 2)
      objFILE.WriteLine (strLBL & strVal)
    End If
    
    objFILE.WriteBlankLines (1)
    objFILE.WriteLine ("--      SGAS     KRGAS     KROIL      PCOG")
    
    For ii = 1 To objRock.NWet
      strVal = objUtil.Nbr2Str(objRock.GetSNWet(ii), 12, 4)
      objFILE.Write (strVal)

      strVal = objUtil.Nbr2Str(objRock.GetKRGas(ii), 10, 4)
      objFILE.Write (strVal)

      strVal = objUtil.Nbr2Str(objRock.GetKROil(ii), 10, 4)
      objFILE.Write (strVal)
      
      objFILE.WriteLine ("     0.000")
    Next ii
    
    objFILE.WriteLine ("/")
    objFILE.WriteBlankLines (1)
    
    objFILE.Close
  End If
  Set objFILE = Nothing

  Call InfoMSG("Eclipse output complete!", "Files: " & fileIDs)
End Sub
