VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsHTML"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private objFSO As FileSystemObject       'System I/O object
Private objFILE As TextStream            'File object

Private pvtHTMLEnable As Boolean         'Enable HTML output

Private pvtFileName As String            'Report file name

Private Sub Class_Initialize()
  HTMLEnable = False
  FileName = "sample.htm"
End Sub

Private Sub Class_Terminate()
  On Error Resume Next
  If HTMLEnable Then
    Call htmlEnd
    Set objFILE = Nothing
    Set objFSO = Nothing
  End If
End Sub
'
'============================== Properties ====================================
'
'
'---HTML enable
'
Public Property Get HTMLEnable() As String
  HTMLEnable = pvtHTMLEnable
End Property

Public Property Let HTMLEnable(ByVal vNewValue As String)
  pvtHTMLEnable = vNewValue
  If pvtHTMLEnable Then
    Set objFSO = New FileSystemObject
    Set objFILE = objFSO.CreateTextFile(FileName, True)
    Call htmlHeader
  End If
End Property
'
'---File name
'
Public Property Get FileName() As String
  FileName = pvtFileName
End Property

Public Property Let FileName(ByVal vNewValue As String)
  pvtFileName = vNewValue
End Property
'
'============================== Methods ====================================
'
'
'---Build html header method
'
Public Sub htmlHeader()
  Dim ii As Integer

  If HTMLEnable Then
    objFILE.WriteLine ("<HTML><HEAD>")
    objFILE.WriteLine ("<STYLE type='text/css'>")
    objFILE.WriteLine ("EM.reg {color:black; font-family:arial; ")
    objFILE.WriteLine ("font-style:italic; font-weight:500; font-size:10pt}")
    objFILE.WriteLine ("EM.t   {color:blue; font-family:arial; font-style:italic; ")
    objFILE.WriteLine ("font-weight:bold; font-size:13pt}")
    objFILE.WriteLine ("EM.st  {line-height:150%; font-weight:bold; color:black; ")
    objFILE.WriteLine ("font-family:arial; font-style:normal; font-size:11pt}")
    objFILE.WriteLine ("EM.stu {text-decoration:underline; line-height:150%; font-weight:bold; color:black; ")
    objFILE.WriteLine ("font-family:arial; font-style:normal; font-size:11pt}")
    objFILE.WriteLine ("EM.sst {font-weight:bold; color:green; font-family:arial; ")
    objFILE.WriteLine ("font-style:normal; text-decoration:nounderline; font-size:9pt}")
    objFILE.WriteLine ("</STYLE></HEAD>")
    objFILE.WriteLine ("<BODY>")
    defaultTABLE
  End If

End Sub
'
'---Output html end tag method
'
Public Sub htmlEnd()
  If HTMLEnable Then
    objFILE.WriteLine ("</TABLE></BODY></HTML>")
  End If
End Sub
'
'---Output html horizontal rule
'
Public Sub HLine()
  If HTMLEnable Then
    objFILE.Write ("<TR>")
    objFILE.WriteLine ("<TD colspan=3><HR></TD>")
    objFILE.Write ("</TR>")
  End If
End Sub
'
'---Start default table
'
Public Sub defaultTABLE()
  If HTMLEnable Then
    objFILE.WriteLine ("<TABLE cols=3 width=800 cellpadding=4>")
    objFILE.Write ("<TR>")
    objFILE.WriteLine ("<TD width='33%'></TD>")
    objFILE.WriteLine ("<TD width='33%'></TD>")
    objFILE.WriteLine ("<TD width='34%'></TD>")
    objFILE.Write ("</TR>")
  End If
End Sub
'
'---Terminate default table and start a new one
'
Public Sub startTABLE(colsIN As Integer, ColHead() As String)
  
  Dim ii As Integer
  
  If HTMLEnable Then
    objFILE.WriteLine ("</TABLE><TABLE align='center' border=1 cols=" & colsIN & _
                       " cellpadding=4>")
                       
    objFILE.WriteLine ("<tr valign='bottom'>")
    For ii = 1 To colsIN
      objFILE.WriteLine ("<TD align='right' width=85><EM class='stu'>" & _
                         ColHead(ii) & "</EM></TD>")
    Next ii
    objFILE.Write ("</TR>")
  End If

End Sub
'
'---Table data
'
Public Sub dataTABLE(colsIN As Integer, Column() As String)
  
  Dim ii As Integer
  
  If HTMLEnable Then
    objFILE.WriteLine ("<tr>")
    For ii = 1 To colsIN
      objFILE.WriteLine ("<TD align='right'><EM class='sst'>" & Column(ii) & "</EM></TD>")
    Next ii
    objFILE.Write ("</TR>")
  End If

End Sub
'
'---Terminate table and return to default
'
Public Sub endTABLE()
  If HTMLEnable Then
    objFILE.WriteLine ("</TABLE>")
    defaultTABLE
  End If
End Sub
'
'---Output html title line style 1
'
Public Sub LabelOne(Optional strLEFT As String, Optional strCEN As String, _
                    Optional strRIGHT As String)
  If HTMLEnable Then
    objFILE.Write ("<TR>")
    objFILE.WriteLine ("<TD align='left'><EM class='t'>" & strLEFT & "</EM></TD>")
    objFILE.WriteLine ("<TD align='center'><EM class='t'>" & strCEN & "</EM></TD>")
    objFILE.WriteLine ("<TD align='right'><EM class='t'>" & strRIGHT & "</EM></TD>")
    objFILE.Write ("</TR>")
  End If
End Sub
'
'---Output html title line style 2
'
Public Sub LabelTwo(Optional strLEFT As String, Optional strCEN As String, _
                    Optional strRIGHT As String)
  If HTMLEnable Then
    objFILE.Write ("<TR>")
    objFILE.WriteLine ("<TD align='left'><EM class='st'>" & strLEFT & "</EM></TD>")
    objFILE.WriteLine ("<TD align='center'><EM class='st'>" & strCEN & "</EM></TD>")
    objFILE.WriteLine ("<TD align='right'><EM class='st'>" & strRIGHT & "</EM></TD>")
    objFILE.Write ("</TR>")
  End If
End Sub
'
'---Output html title line style 2 (underline)
'
Public Sub LabelTwoU(Optional strLEFT As String, Optional strCEN As String, _
                     Optional strRIGHT As String)
  If HTMLEnable Then
    objFILE.Write ("<TR>")
    objFILE.WriteLine ("<TD align='left'><EM class='stu'>" & strLEFT & "</EM></TD>")
    objFILE.WriteLine ("<TD align='center'><EM class='stu'>" & strCEN & "</EM></TD>")
    objFILE.WriteLine ("<TD align='right'><EM class='stu'>" & strRIGHT & "</EM></TD>")
    objFILE.Write ("</TR>")
  End If
End Sub
'
'---Output "label: value"
'
Public Sub LabelValue(lblIN As String, valIN As String)
  If HTMLEnable Then
    objFILE.Write ("<TR>")
    objFILE.WriteLine ("<TD align='right'><EM class='reg'>" & lblIN & "</EM></TD>")
    objFILE.WriteLine ("<TD align='left'><EM class='sst'>" & valIN & "</EM></TD>")
    objFILE.Write ("</TR>")
  End If
End Sub
