VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsP3IO"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'
'Title: clsP3IO
'
'Author: D.V. Allred (Analytics CIS, 07/Jan/2002)
'
'Description: Provide I/O for MHA Petroleum Properties Program MS ACCESS
'             database (P3.MDB).  If database exists, set property "P3Found" to TRUE.
'             Search registry for P3.EXE and use its location to find P3.MDB
'
'Assumptions: Object created in frmMain
'
Option Explicit

Private Const strCONNECT = "Provider=MSDASQL;" & _
                           "Driver={Microsoft Access Driver (*.mdb)};" & _
                           "uid=Admin; pwd=dbMHA; "

Private dbCONN As ADODB.Connection
Private p3ioFOUND As Boolean

Private Sub Class_Initialize()
  Set dbCONN = New ADODB.Connection
  P3FOUND = False
End Sub

Private Sub Class_Terminate()
  On Error Resume Next
  dbCONN.Close
  Set dbCONN = Nothing
End Sub
'
'============================== Properties ====================================
'
Public Property Get P3FOUND() As Variant
  P3FOUND = p3ioFOUND
End Property

Public Property Let P3FOUND(ByVal vNewValue As Variant)
  p3ioFOUND = vNewValue
End Property
'
'============================== Methods ====================================
'
Public Function P3Open()
  Dim strDBQ As String
  
  On Error GoTo ErrOpen
  strDBQ = GetKeyValue(HKEY_LOCAL_MACHINE, _
           "software\microsoft\windows\currentversion\app paths\p3.exe", "")
  strDBQ = "DBQ=" & Replace(strDBQ, ".exe", ".mdb") & ";"
  
  dbCONN.ConnectionString = strCONNECT & strDBQ
  dbCONN.Open
  P3FOUND = True
  Exit Function
  
ErrOpen:
  P3FOUND = False

End Function

Public Function NewREC(tableIN As String) As ADODB.Recordset
  Dim rsNEW As New ADODB.Recordset
  
  rsNEW.CursorType = adOpenKeyset
  rsNEW.LockType = adLockPessimistic
  rsNEW.Open tableIN, dbCONN, , , adCmdTable
  rsNEW.AddNew
  
  Set NewREC = rsNEW
  
  Set rsNEW = Nothing
End Function

Public Sub SaveREC(rsREC As ADODB.Recordset)
  rsREC.Update
End Sub

Public Function GetProjects() As ADODB.Recordset
  Dim strSQL As String
  Dim rsProj As New ADODB.Recordset
  
  rsProj.CursorType = adOpenKeyset
  rsProj.LockType = adLockPessimistic
  
  strSQL = "Select PrjName, DateCreate, CreatedBy, PrjDesc, PrjID " & _
           "From tblProject Order by PrjName"
  rsProj.Open strSQL, dbCONN
  
  Set GetProjects = rsProj
  
  Set rsProj = Nothing
End Function

Public Function GetProject(prjIN As Long) As ADODB.Recordset
  Dim strSQL As String
  Dim rsProj As New ADODB.Recordset
  
  rsProj.CursorType = adOpenKeyset
  rsProj.LockType = adLockPessimistic
  strSQL = "Select * From tblProject Where PrjID = " & prjIN
  rsProj.Open strSQL, dbCONN
  
  'CustID = rsCust!CustID
  'CustName = rsCust!Name
  
  Set GetProject = rsProj
  
  Set rsProj = Nothing
End Function

Public Function LoadPrjTbl(tblIN As String, prjIN As Long) As ADODB.Recordset
  Dim strSQL As String
  Dim rsProj As New ADODB.Recordset
  
  rsProj.CursorType = adOpenKeyset
  rsProj.LockType = adLockPessimistic
  strSQL = "Select * " & _
           "From " & tblIN & " " & _
           "Where PrjID = " & prjIN
  rsProj.Open strSQL, dbCONN
  
  Set LoadPrjTbl = rsProj
  
  Set rsProj = Nothing
End Function

Public Sub SaveFluid(prjIN As Long)
'
'---Save current fluid spec parameters to database
'
  Set rsFluid = objP3IO.NewREC("tblFluidSpec")
  
  rsFluid!PrjID = prjIN
  rsFluid!PhaseOil = 0
  If objFluid.PhaseOil Then rsFluid!PhaseOil = 1
  rsFluid!PhaseGas = 0
  If objFluid.PhaseGas Then rsFluid!PhaseGas = 1
  rsFluid!PhaseWater = 0
  If objFluid.PhaseWater Then rsFluid!PhaseWater = 1
  
  rsFluid!StdPressure = objFluid.StdP
  rsFluid!StdTemp = objFluid.StdTf
  rsFluid!StdTempUnits = "F"
    
  rsFluid!RESTEMP = objFluid.ResTf
  rsFluid!ResTempUnits = "F"
    
  Call objP3IO.SaveREC(rsFluid)
End Sub

Public Sub SavePressure(prjIN As Long)
  Dim ii As Integer
'
'---Save current Pressure parameters to database
'
  Set rsPressure = objP3IO.NewREC("tblPressureSpec")
  
  rsPressure!PrjID = prjIN
  rsPressure!PrRange = objPrs.PrRange
  rsPressure!MinPr = objPrs.PrMin
  rsPressure!InitPr = objPrs.PrIni
  rsPressure!MaxPr = objPrs.PrMax
  
  If objPrs.PrRange = "I" Then
    For ii = 1 To 18
      rsPressure("p" & ii) = objPrs.GetPRSi(ii)
    Next ii
  End If
    
  Call objP3IO.SaveREC(rsPressure)
End Sub

Public Sub SaveOil(prjIN As Long)
  Dim ii As Integer
'
'---Save current Oil parameters to database
'
  Set rsOil = objP3IO.NewREC("tblOilGravity")
  
  rsOil!PrjID = prjIN
  rsOil!API = objOil.API
  rsOil!SpecGrav = objOil.OilSG
  rsOil!SepGasGrav = objOil.SepGG
  rsOil!SepP = objOil.SepP
  rsOil!SepT = objOil.SepTf
  rsOil!SepTUnits = "F"
  rsOil!InitGO = objOil.RSI
  rsOil!BPP = objOil.Pbp
    
  Call objP3IO.SaveREC(rsOil)

End Sub

Public Sub SaveGas(prjIN As Long)
  Dim ii As Integer
'
'---Save current Gas parameters to database
'
  Set rsGas = objP3IO.NewREC("tblGasComp")
  
  rsGas!PrjID = prjIN
  rsGas!GasEntry = objGas.GasEntry
  rsGas!GasGrav = objGas.GasGrav
  rsGas!MFnitrogen = objGas.mfN
  rsGas!mfCO2 = objGas.mfCO2
  rsGas!mfH2S = objGas.mfH2S
  For ii = 1 To 15
    rsGas("gc" & ii) = objGas.GetGC(ii)
  Next ii
    
  Call objP3IO.SaveREC(rsGas)

End Sub

Public Sub SaveWater(prjIN As Long)
  
  Dim ii As Integer
'
'---Save current Water parameters to database
'
  Set rsWater = objP3IO.NewREC("tblWater")
  
  rsWater!PrjID = prjIN
  rsWater!PPMSalinity = objWat.PPM
  rsWater!PERSalinity = objWat.PER
    
  Call objP3IO.SaveREC(rsWater)

End Sub

Public Sub SaveRock(prjIN As Long)

  Dim ii As Integer
'
'---Save current Rock parameters to database
'
  Set rsRock = objP3IO.NewREC("tblRock")
  
  rsRock!PrjID = prjIN
  rsRock!RockType = objRock.Fluids
  rsRock!DrainType = objRock.Displace
  rsRock!LithType = objRock.Lith
  rsRock!WetType = objRock.Wet
  rsRock!CorrType = objRock.CORR
  rsRock!SWC = objRock.SWC
  rsRock!SORW = objRock.SORW
  rsRock!SORG = objRock.SORG
  rsRock!SGCrit = objRock.SGCrit
  rsRock!CoreyK = objRock.CoreyK
  rsRock!CoreyN = objRock.CoreyN
  rsRock!HRPoro = objRock.HRPoro
  rsRock!HRAir = objRock.HRAir
  rsRock!HRKrg = objRock.HRKrg
    
  Call objP3IO.SaveREC(rsRock)

End Sub

Public Sub DelProject(prjIN As Long)
  Dim strSQL As String
'
'---Delete project records
'
  strSQL = "Delete From tblWater Where PrjID = " & prjIN
  dbCONN.Execute (strSQL)
  
  strSQL = "Delete From tblRock Where PrjID = " & prjIN
  dbCONN.Execute (strSQL)
  
  strSQL = "Delete From tblPressureSpec Where PrjID = " & prjIN
  dbCONN.Execute (strSQL)
  
  strSQL = "Delete From tblOilGravity Where PrjID = " & prjIN
  dbCONN.Execute (strSQL)
  
  strSQL = "Delete From tblGasCOmp Where PrjID = " & prjIN
  dbCONN.Execute (strSQL)
  
  strSQL = "Delete From tblFluidSpec Where PrjID = " & prjIN
  dbCONN.Execute (strSQL)
  
  strSQL = "Delete From tblProject Where PrjID = " & prjIN
  dbCONN.Execute (strSQL)

End Sub
