VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsReport"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private objFSO As FileSystemObject       'System I/O object
Private objFILE As TextStream            'File object

Private pvtFileName As String            'Report file name
Private pvtFormatOpt As String           'Format option: TEXT, HTML, BOTH

Private pvtIncludeOil As Boolean         'Include OIL properties in report
Private pvtIncludeGAS As Boolean         'Include GAS properties in report
Private pvtIncludeWAT As Boolean         'Include WATER properties in report
Private pvtIncludeROCK As Boolean        'Include Rock properties in report

Private pvtPrjName As String             'Report Project name
Private pvtCreatedBy As String           'Report User
Private pvtPrjDesc As String             'Report Description
Private pvtCompany As String             'Report Company
Private pvtField As String               'Report Field
Private pvtReservoir As String           'Report Reservoir

Private Sub Class_Initialize()
  Set objFSO = New FileSystemObject
  FileName = "Sample.txt"
  IncludeOIL = False
  IncludeGAS = False
  IncludeWAT = False
  IncludeROCK = False
  FormatOpt = "BOTH"
End Sub

Private Sub Class_Terminate()
  On Error Resume Next
  Set objFILE = Nothing
  Set objFSO = Nothing
End Sub
'
'============================== Properties ====================================
'
'
'---File name
'
Public Property Get FileName() As String
  FileName = pvtFileName
End Property

Public Property Let FileName(ByVal vNewValue As String)
  pvtFileName = vNewValue
End Property
'
'---Format option
'
Public Property Get FormatOpt() As String
  FormatOpt = pvtFormatOpt
End Property

Public Property Let FormatOpt(ByVal vNewValue As String)
  pvtFormatOpt = vNewValue
End Property
'
'---Project name
'
Public Property Get PrjName() As String
  PrjName = pvtPrjName
End Property

Public Property Let PrjName(ByVal vNewValue As String)
  pvtPrjName = vNewValue
End Property
'
'---Created by
'
Public Property Get CreatedBy() As String
  CreatedBy = pvtCreatedBy
End Property

Public Property Let CreatedBy(ByVal vNewValue As String)
  pvtCreatedBy = vNewValue
End Property
'
'---Project desc
'
Public Property Get PrjDesc() As String
  PrjDesc = pvtPrjDesc
End Property

Public Property Let PrjDesc(ByVal vNewValue As String)
  pvtPrjDesc = vNewValue
End Property
'
'---Company
'
Public Property Get Company() As String
  Company = pvtCompany
End Property

Public Property Let Company(ByVal vNewValue As String)
  pvtCompany = vNewValue
End Property
'
'---Field
'
Public Property Get Field() As String
  Field = pvtField
End Property

Public Property Let Field(ByVal vNewValue As String)
  pvtField = vNewValue
End Property
'
'---Project desc
'
Public Property Get Reservoir() As String
  Reservoir = pvtReservoir
End Property

Public Property Let Reservoir(ByVal vNewValue As String)
  pvtReservoir = vNewValue
End Property
'
'---Report inclusions
'
Public Property Get IncludeOIL() As Boolean
  IncludeOIL = pvtIncludeOil
End Property

Public Property Let IncludeOIL(ByVal vNewValue As Boolean)
  pvtIncludeOil = vNewValue
End Property

Public Property Get IncludeGAS() As Boolean
  IncludeGAS = pvtIncludeGAS
End Property

Public Property Let IncludeGAS(ByVal vNewValue As Boolean)
  pvtIncludeGAS = vNewValue
End Property

Public Property Get IncludeWAT() As Boolean
  IncludeWAT = pvtIncludeWAT
End Property

Public Property Let IncludeWAT(ByVal vNewValue As Boolean)
  pvtIncludeWAT = vNewValue
End Property

Public Property Get IncludeROCK() As Boolean
  IncludeROCK = pvtIncludeROCK
End Property

Public Property Let IncludeROCK(ByVal vNewValue As Boolean)
  pvtIncludeROCK = vNewValue
End Property
'
'============================== Methods ====================================
'
'
'---Build report method
'
Public Sub Execute()
  Dim ii As Integer
  Dim strLBL As String, strLBL2 As String, strVAL As String
  Dim objHTML As clsHTML
  Dim ColData(1 To 7) As String
'
'---Open new report file
'
  Set objFILE = objFSO.CreateTextFile(FileName, True)
  Set objHTML = New clsHTML
  objHTML.HTMLEnable = True
'
'---Report title
'
  strLBL = "Malkewicz, Hueni & Associates"
  strLBL2 = Format(Now, "dd-mmm-yyyy hh:nn am/pm")
  objFILE.WriteLine (strLBL & Space(20) & strLBL2)
  objHTML.LabelOne strLBL, , strLBL2
  
  strLBL = "Petroleum Properties Program (v" & _
                      App.Major & "." & App.Minor & App.Revision & ")"
  objFILE.WriteLine (strLBL)
  objHTML.LabelTwo , strLBL
  objHTML.HLine
  objFILE.WriteBlankLines (2)
'
'---Report header
'
  strLBL = "Company: "
  objFILE.WriteLine (strLBL & Company)
  objHTML.LabelValue strLBL, Company

  strLBL = "Field: "
  objFILE.WriteLine (strLBL & Field)
  objHTML.LabelValue strLBL, Field
  
  strLBL = "Reservoir: "
  objFILE.WriteLine (strLBL & Reservoir)
  objHTML.LabelValue strLBL, Reservoir
  
  strLBL = "Location: "
  objFILE.WriteLine (strLBL & PrjDesc)
  objHTML.LabelValue strLBL, PrjDesc
  
  strLBL = "Engineer: "
  objFILE.WriteLine (strLBL & CreatedBy)
  objHTML.LabelValue strLBL, CreatedBy
  
  objFILE.WriteBlankLines (1)
'
'---Input data
'
  If IncludeOIL Or IncludeGAS Or IncludeWAT Then
    objFILE.WriteLine ("----------------------------------")
    objFILE.WriteLine ("       STANDARD CONDITIONS        ")
    objFILE.WriteLine ("----------------------------------")
    objFILE.WriteBlankLines (1)
    objHTML.LabelTwoU "Standard Conditions"
    
    strLBL = "Standard Pressure: "
    strVAL = Format(objFluid.StdP, "0.0") & " (psia)"
    objFILE.WriteLine (strLBL & strVAL)
    objHTML.LabelValue strLBL, strVAL
  
    strLBL = "             Temp: "
    strVAL = Format(objFluid.StdTf, "0.0") & " (F)"
    objFILE.WriteLine (strLBL & strVAL)
    objHTML.LabelValue strLBL, strVAL
  
    strLBL = "Reservoir    Temp: "
    strVAL = Format(objFluid.ResTf, "0.0") & " (F)"
    objFILE.WriteLine (strLBL & strVAL)
    objHTML.LabelValue strLBL, strVAL
  End If
'
'---Oil Properties
'
  If IncludeOIL Then
    
    objFILE.WriteBlankLines (1)
    objFILE.WriteLine ("----------------------------------")
    objFILE.WriteLine ("          OIL PROPERTIES          ")
    objFILE.WriteLine ("----------------------------------")
    objFILE.WriteBlankLines (1)
    objHTML.HLine
    objHTML.LabelTwoU "Oil Properties"
    
    strLBL = "API Gravity: "
    strVAL = objOil.API
    objFILE.WriteLine (strLBL & strVAL)
    objHTML.LabelValue strLBL, strVAL
    
    strLBL = "           Specific Gravity: "
    strVAL = objOil.OilSG
    objFILE.WriteLine (strLBL & strVAL)
    objHTML.LabelValue strLBL, strVAL
    
    strLBL = "Separator Gas Gravity: "
    strVAL = objOil.SepGG
    objFILE.WriteLine (strLBL & strVAL)
    objHTML.LabelValue strLBL, strVAL
    
    strLBL = "             Pressure: "
    strVAL = objOil.SepP & " (psia)"
    objFILE.WriteLine (strLBL & strVAL)
    objHTML.LabelValue strLBL, strVAL
    
    strLBL = "                 Temp: "
    strVAL = objOil.SepTf & " (F)"
    objFILE.WriteLine (strLBL & strVAL)
    objHTML.LabelValue strLBL, strVAL
    
    objFILE.WriteBlankLines (1)
    
    strLBL = "Bubble Point Pressure: "
    strVAL = objUtil.Nbr2Str(objOil.Pbp, 10, 1) & " (psia)"
    objFILE.WriteLine (strLBL & strVAL)
    objHTML.LabelValue strLBL, strVAL
    
    strLBL = "Compressibility @ Pbp: "
    strVAL = objUtil.Nbr2Str(objOil.GetCO(objPrs.BPPi), 10, 7) & " (psia)"
    objFILE.WriteLine (strLBL & strVAL)
    objHTML.LabelValue strLBL, strVAL
    
    strLBL = "StockTank Oil Density: "
    strVAL = objUtil.Nbr2Str(objOil.STDenOil, 10, 3) & " (lb/scf)"
    objFILE.WriteLine (strLBL & strVAL)
    objHTML.LabelValue strLBL, strVAL
    
    strLBL = "StockTank Gas Density: "
    strVAL = objUtil.Nbr2Str(objOil.STDenGas, 10, 5) & " (lb/scf)"
    objFILE.WriteLine (strLBL & strVAL)
    objHTML.LabelValue strLBL, strVAL
    
    strLBL = "Initial GOR-Separator: "
    strVAL = objUtil.Nbr2Str(objOil.RSISep, 10, 1) & " (scf/stb)"
    objFILE.WriteLine (strLBL & strVAL)
    objHTML.LabelValue strLBL, strVAL
    
    strLBL = "            StockTank: "
    strVAL = objUtil.Nbr2Str(objOil.RSITank, 10, 1) & " (scf/stb)"
    objFILE.WriteLine (strLBL & strVAL)
    objHTML.LabelValue strLBL, strVAL
    
    strLBL = "                Total: "
    strVAL = objUtil.Nbr2Str(objOil.RSI, 10, 1) & " (scf/stb)"
    objFILE.WriteLine (strLBL & strVAL)
    objHTML.LabelValue strLBL, strVAL
    
    objFILE.WriteBlankLines (1)
    objFILE.WriteLine ("Undersaturated properties above the bubble point:")
    objFILE.WriteBlankLines (1)
    objFILE.WriteLine ("                 Volume Dissolved")
    objFILE.WriteLine ("   Pressure      Factor       GOR    Viscosity      Density")
    objFILE.WriteLine ("     (psia)    (rb/stb)  (scf/stb)        (cp)     (lb/ft3)")
    objFILE.WriteLine (" ----------  ----------  ---------  ----------   ----------")
    
    objHTML.LabelTwo , "Undersaturated properties above the bubble point:"
    ColData(1) = "Pressure (psia)"
    ColData(2) = "Volume Factor (rb/stb)"
    ColData(3) = "Dissolved GOR (scf/stb)"
    ColData(4) = "Viscosity (cp)"
    ColData(5) = "Density (lb/ft3)"
    objHTML.startTABLE 5, ColData
    
    For ii = 1 To objPrs.NPRSo
      ColData(1) = objUtil.Nbr2Str(objPrs.GetPRSo(ii), 11, 1)
      objFILE.Write (ColData(1))
      
      ColData(2) = objUtil.Nbr2Str(objOil.GetBO(ii), 12, 4)
      objFILE.Write (ColData(2))
      
      ColData(3) = objUtil.Nbr2Str(objOil.GetRSO(ii), 11, 1)
      objFILE.Write (ColData(3))
      
      ColData(4) = objUtil.Nbr2Str(objOil.GetMUO(ii), 12, 3)
      objFILE.Write (ColData(4))
      
      ColData(5) = objUtil.Nbr2Str(objOil.GetRHOO(ii), 13, 3)
      objFILE.WriteLine (ColData(5))
      
      objHTML.dataTABLE 5, ColData
    Next ii
    objHTML.endTABLE
    
    objFILE.WriteBlankLines (2)
    objFILE.WriteLine ("Extended Saturated oil properties:")
    objFILE.WriteBlankLines (1)
    objFILE.WriteLine ("                 Volume Dissolved")
    objFILE.WriteLine ("   Pressure      Factor       GOR    Viscosity      Density")
    objFILE.WriteLine ("     (psia)    (rb/stb)  (scf/stb)        (cp)     (lb/ft3)")
    objFILE.WriteLine (" ----------  ----------  ---------  ----------   ----------")
    
    objHTML.LabelTwo , "Extended Saturated oil properties:"
    ColData(1) = "Pressure (psia)"
    ColData(2) = "Volume Factor (rb/stb)"
    ColData(3) = "Dissolved GOR (scf/stb)"
    ColData(4) = "Viscosity (cp)"
    ColData(5) = "Density (lb/ft3)"
    objHTML.startTABLE 5, ColData
    
    For ii = 1 To objPrs.NPRSo
      ColData(1) = objUtil.Nbr2Str(objPrs.GetPRSo(ii), 11, 1)
      objFILE.Write (ColData(1))
      
      ColData(2) = objUtil.Nbr2Str(objOil.GetBOS(ii), 12, 4)
      objFILE.Write (ColData(2))
      
      ColData(3) = objUtil.Nbr2Str(objOil.GetRSOS(ii), 11, 1)
      objFILE.Write (ColData(3))
      
      ColData(4) = objUtil.Nbr2Str(objOil.GetMUOS(ii), 12, 3)
      objFILE.Write (objUtil.Nbr2Str(objOil.GetMUOS(ii), 12, 3))
      
      ColData(5) = objUtil.Nbr2Str(objOil.GetRHOOS(ii), 13, 3)
      objFILE.WriteLine (ColData(5))
      
      objHTML.dataTABLE 5, ColData
    Next ii
    objHTML.endTABLE
  End If
'
'---Gas Properties
'
  If IncludeOIL Or IncludeGAS Then
    
    objFILE.WriteBlankLines (1)
    objFILE.WriteLine ("----------------------------------")
    objFILE.WriteLine ("          GAS PROPERTIES          ")
    objFILE.WriteLine ("----------------------------------")
    objFILE.WriteBlankLines (1)
    objHTML.HLine
    objHTML.LabelTwoU "Gas Properties"
    
    If objGas.GasEntry = "G" Then
    
      objFILE.WriteLine ("Gas Gravity and Inerts")
      objHTML.LabelTwo "Gas Gravity and Inerts"
      
      strLBL = "                   Gas Gravity: "
      strVAL = objUtil.Nbr2Str(objGas.GasGrav, 10, 3)
      objFILE.WriteLine (strLBL & strVAL)
      objHTML.LabelValue strLBL, strVAL
      
      
      strLBL = "           Nitrogen, mole frac: "
      strVAL = objUtil.Nbr2Str(objGas.mfN, 10, 3)
      objFILE.WriteLine (strLBL & strVAL)
      objHTML.LabelValue strLBL, strVAL
      
      strLBL = "     Carbon Dioxide, mole frac: "
      strVAL = objUtil.Nbr2Str(objGas.mfCO2, 10, 3)
      objFILE.WriteLine (strLBL & strVAL)
      objHTML.LabelValue strLBL, strVAL
      
      strLBL = "   Hydrogen Sulfide, mole frac: "
      strVAL = objUtil.Nbr2Str(objGas.mfH2S, 10, 3)
      objFILE.WriteLine (strLBL & strVAL)
      objHTML.LabelValue strLBL, strVAL
    Else
      objFILE.WriteLine ("Gas Composition")
      objHTML.LabelTwo "Gas Composition"
      
      strLBL = "            Methane: "
      strVAL = objUtil.Nbr2Str(objGas.GetGC(1), 6, 4)
      objFILE.WriteLine (strLBL & strVAL)
      objHTML.LabelValue strLBL, strVAL
      
      strLBL = "             Ethane: "
      strVAL = objUtil.Nbr2Str(objGas.GetGC(2), 6, 4)
      objFILE.WriteLine (strLBL & strVAL)
      objHTML.LabelValue strLBL, strVAL
      
      strLBL = "            Propane: "
      strVAL = objUtil.Nbr2Str(objGas.GetGC(3), 6, 4)
      objFILE.WriteLine (strLBL & strVAL)
      objHTML.LabelValue strLBL, strVAL
      
      strLBL = "           i-Butane: "
      strVAL = objUtil.Nbr2Str(objGas.GetGC(4), 6, 4)
      objFILE.WriteLine (strLBL & strVAL)
      objHTML.LabelValue strLBL, strVAL
      
      strLBL = "           n-Butane: "
      strVAL = objUtil.Nbr2Str(objGas.GetGC(5), 6, 4)
      objFILE.WriteLine (strLBL & strVAL)
      objHTML.LabelValue strLBL, strVAL
      
      strLBL = "          i-Pentane: "
      strVAL = objUtil.Nbr2Str(objGas.GetGC(6), 6, 4)
      objFILE.WriteLine (strLBL & strVAL)
      objHTML.LabelValue strLBL, strVAL
      
      strLBL = "          n-Pentane: "
      strVAL = objUtil.Nbr2Str(objGas.GetGC(7), 6, 4)
      objFILE.WriteLine (strLBL & strVAL)
      objHTML.LabelValue strLBL, strVAL
      
      strLBL = "             Hexane: "
      strVAL = objUtil.Nbr2Str(objGas.GetGC(8), 6, 4)
      objFILE.WriteLine (strLBL & strVAL)
      objHTML.LabelValue strLBL, strVAL
      
      strLBL = "            Heptane: "
      strVAL = objUtil.Nbr2Str(objGas.GetGC(9), 6, 4)
      objFILE.WriteLine (strLBL & strVAL)
      objHTML.LabelValue strLBL, strVAL
      
      strLBL = "             Octane: "
      strVAL = objUtil.Nbr2Str(objGas.GetGC(10), 6, 4)
      objFILE.WriteLine (strLBL & strVAL)
      objHTML.LabelValue strLBL, strVAL
      
      strLBL = "             Nonane: "
      strVAL = objUtil.Nbr2Str(objGas.GetGC(11), 6, 4)
      objFILE.WriteLine (strLBL & strVAL)
      objHTML.LabelValue strLBL, strVAL
      
      strLBL = "             Decane: "
      strVAL = objUtil.Nbr2Str(objGas.GetGC(12), 6, 4)
      objFILE.WriteLine (strLBL & strVAL)
      objHTML.LabelValue strLBL, strVAL
      
      strLBL = "           Nitrogen: "
      strVAL = objUtil.Nbr2Str(objGas.GetGC(13), 6, 4)
      objFILE.WriteLine (strLBL & strVAL)
      objHTML.LabelValue strLBL, strVAL
      
      strLBL = "     Carbon Dioxide: "
      strVAL = objUtil.Nbr2Str(objGas.GetGC(14), 6, 4)
      objFILE.WriteLine (strLBL & strVAL)
      objHTML.LabelValue strLBL, strVAL
      
      strLBL = "   Hydrogen Sulfide: "
      strVAL = objUtil.Nbr2Str(objGas.GetGC(15), 6, 4)
      objFILE.WriteLine (strLBL & strVAL)
      objHTML.LabelValue strLBL, strVAL
    End If
    
    objFILE.WriteBlankLines (1)
      
    strLBL = "         Critical Pressure: "
    strVAL = objUtil.Nbr2Str(objGas.pC, 10, 2) & " (psia)"
    objFILE.WriteLine (strLBL & strVAL)
    objHTML.LabelValue strLBL, strVAL
      
    strLBL = "      Critical Temperature: "
    strVAL = objUtil.Nbr2Str(objGas.tC, 10, 2) & " (R)"
    objFILE.WriteLine (strLBL & strVAL)
    objHTML.LabelValue strLBL, strVAL
      
    strLBL = "Pseudo-Reduced Temperature: "
    strVAL = objUtil.Nbr2Str(objGas.PTR, 10, 3)
    objFILE.WriteLine (strLBL & strVAL)
    objHTML.LabelValue strLBL, strVAL
      
    strLBL = "     StockTank Gas Density: "
    strVAL = objUtil.Nbr2Str(objGas.STDenGas, 10, 5) & " (lb/scf)"
    objFILE.WriteLine (strLBL & strVAL)
    objHTML.LabelValue strLBL, strVAL
    
    objFILE.WriteBlankLines (1)
    objFILE.WriteLine ("            Pseudo-Reduced   Gas (Z)")
    objFILE.WriteLine ("   Pressure    Pressure    Deviation          P/Z")
    objFILE.WriteLine ("     (psia)                 Factor         (psia)")
    objFILE.WriteLine (" ----------  ----------   ----------   ----------")
    
    ColData(1) = "Pressure (psia)"
    ColData(2) = "Pseudo-Reduced Pressure"
    ColData(3) = "Gas (Z) Deviation Factor"
    ColData(4) = "P/Z (psia)"
    objHTML.startTABLE 4, ColData
    
    For ii = 1 To objPrs.NPRSo
      ColData(1) = objUtil.Nbr2Str(objPrs.GetPRSo(ii), 11, 1)
      objFILE.Write (ColData(1))
      
      ColData(2) = objUtil.Nbr2Str(objGas.GetPPR(ii), 12, 3)
      objFILE.Write (ColData(2))
      
      ColData(3) = objUtil.Nbr2Str(objGas.GetZ(ii), 13, 3)
      objFILE.Write (ColData(3))
      
      ColData(4) = objUtil.Nbr2Str(objGas.GetPZ(ii), 13, 1)
      objFILE.WriteLine (ColData(4))
      
      objHTML.dataTABLE 4, ColData
    Next ii
    objHTML.endTABLE
    
    objFILE.WriteBlankLines (2)
    objFILE.WriteLine ("             Gas Volume               Compress-             Real Gas Potential")
    objFILE.WriteLine ("   Pressure      Factor  Viscosity     ibility      Density      m(p)/1E06")
    objFILE.WriteLine ("     (psia)   (rcf/scf)       (cp)     (psi-1)     (lb/rcf)     (psia^2/cp)")
    objFILE.WriteLine (" ----------  ----------  ---------  ----------   ----------    -----------")
    
    ColData(1) = "Pressure (psia)"
    ColData(2) = "Gas Volume Factor (rcf/scf)"
    ColData(3) = "Viscosity (cp)"
    ColData(4) = "Compressibility (psi-1)"
    ColData(5) = "Density (lb/ft3)"
    ColData(6) = "Real Gas Potential m(p)/1E06 (psia^2/cp)"
    objHTML.startTABLE 6, ColData
    
    For ii = 1 To objPrs.NPRSo
      ColData(1) = objUtil.Nbr2Str(objPrs.GetPRSo(ii), 11, 1)
      objFILE.Write (ColData(1))
      
      ColData(2) = objUtil.Nbr2Str(objGas.GetBG(ii), 12, 5)
      objFILE.Write (ColData(2))
      
      ColData(3) = objUtil.Nbr2Str(objGas.GetMUG(ii), 11, 4)
      objFILE.Write (ColData(3))
      
      ColData(4) = objUtil.Nbr2Str(objGas.GetCG(ii), 12, 7)
      objFILE.Write (ColData(4))
      
      ColData(5) = objUtil.Nbr2Str(objGas.GetRHOG(ii), 13, 4)
      objFILE.Write (ColData(5))
      
      ColData(6) = objUtil.Nbr2Str(objGas.GetRMP(ii), 15, 3)
      objFILE.WriteLine (ColData(6))
      
      objHTML.dataTABLE 6, ColData
    Next ii
    objHTML.endTABLE
  End If
'
'---Water Properties
'
  If IncludeWAT Then
    
    objFILE.WriteBlankLines (1)
    objFILE.WriteLine ("----------------------------------")
    objFILE.WriteLine ("         WATER PROPERTIES         ")
    objFILE.WriteLine ("----------------------------------")
    objFILE.WriteBlankLines (1)
    objHTML.HLine
    objHTML.LabelTwoU "Water Properties"
    
    strLBL = "  Weight % Solids: "
    strVAL = objUtil.Nbr2Str(objWat.PER, 10, 1)
    objFILE.WriteLine (strLBL & strVAL)
    objHTML.LabelValue strLBL, strVAL
      
    strLBL = " Dissolved Solids: "
    strVAL = objUtil.Nbr2Str(objWat.PPM, 10, 0) & " (ppm)"
    objFILE.WriteLine (strLBL & strVAL)
    objHTML.LabelValue strLBL, strVAL
      
    strLBL = "StockTank Density: "
    strVAL = objUtil.Nbr2Str(objWat.STDenWat, 10, 3) & " (lb/scf)"
    objFILE.WriteLine (strLBL & strVAL)
    objHTML.LabelValue strLBL, strVAL

    objFILE.WriteBlankLines (2)
    objFILE.WriteLine ("                 Volume  Dissolved                 Compress-")
    objFILE.WriteLine ("   Pressure      Factor        GOR   Viscosity      ibility      Density")
    objFILE.WriteLine ("     (psia)    (rb/stb)  (scf/stb)        (cp)      (psi-1)     (lb/rcf)")
    objFILE.WriteLine (" ----------  ----------  ---------  ----------   ----------    ---------")
    
    ColData(1) = "Pressure (psia)"
    ColData(2) = "Volume Factor (rb/stb)"
    ColData(3) = "Dissolved GOR (scf/stb)"
    ColData(4) = "Viscosity (cp)"
    ColData(5) = "Compressibility (psi-1)"
    ColData(6) = "Density (lb/rcf)"
    objHTML.startTABLE 6, ColData
    
    For ii = 1 To objPrs.NPRSo
      ColData(1) = objUtil.Nbr2Str(objPrs.GetPRSo(ii), 11, 1)
      objFILE.Write (ColData(1))
      
      ColData(2) = objUtil.Nbr2Str(objWat.GetBW(ii), 12, 5)
      objFILE.Write (ColData(2))
      
      ColData(3) = objUtil.Nbr2Str(objWat.GetRSW(ii), 11, 1)
      objFILE.Write (ColData(3))
      
      ColData(4) = objUtil.Nbr2Str(objWat.GetMUW(ii), 12, 3)
      objFILE.Write (ColData(4))
      
      ColData(5) = objUtil.Nbr2Str(objWat.GetCW(ii), 13, 7)
      objFILE.Write (ColData(5))
      
      ColData(6) = objUtil.Nbr2Str(objWat.GetRHOW(ii), 13, 3)
      objFILE.WriteLine (ColData(6))
      
      objHTML.dataTABLE 6, ColData
    Next ii
    objHTML.endTABLE
  End If
'
'---Rock Properties
'
  If IncludeROCK Then
    
    objFILE.WriteBlankLines (1)
    objFILE.WriteLine ("----------------------------------")
    objFILE.WriteLine ("          ROCK PROPERTIES         ")
    objFILE.WriteLine ("----------------------------------")
    objFILE.WriteBlankLines (1)
    objHTML.HLine
    objHTML.LabelTwoU "Rock Properties"
    
    strLBL = "               Fluids: "
    strVAL = "Oil/Water System"
    If objRock.Fluids = 1 Then strVAL = "Gas/Oil System"
    objFILE.WriteLine (strLBL & strVAL)
    objHTML.LabelValue strLBL, strVAL
    
    strLBL = "         Displacement: "
    strVAL = "Drainage"
    If objRock.Displace = 1 Then strVAL = "Imbibition"
    objFILE.WriteLine (strLBL & strVAL)
    objHTML.LabelValue strLBL, strVAL
    
    strLBL = "            Lithology: "
    strVAL = "Sandstone"
    If objRock.Lith = 1 Then strVAL = "Limestone"
    objFILE.WriteLine (strLBL & strVAL)
    objHTML.LabelValue strLBL, strVAL
      
    strLBL = "        Connate Water: "
    strVAL = objUtil.Nbr2Str(objRock.SWC, 8, 2)
    objFILE.WriteLine (strLBL & strVAL)
    objHTML.LabelValue strLBL, strVAL
    
    If objRock.Fluids = 0 Then                           'Oil/Water system
      strLBL = "          Wettability: "
      strVAL = "Water Wet"
      If objRock.Wet = 1 Then strVAL = "Oil Wet"
      objFILE.WriteLine (strLBL & strVAL)
      objHTML.LabelValue strLBL, strVAL
     
      strLBL = "Residual Oil to Water: "
      strVAL = objUtil.Nbr2Str(objRock.SORW, 8, 2)
      objFILE.WriteLine (strLBL & strVAL)
      objHTML.LabelValue strLBL, strVAL
    End If
          
    If objRock.Fluids = 1 Then                           'Gas/Oil system
      strLBL = "  Residual Oil to Gas: "
      strVAL = objUtil.Nbr2Str(objRock.SWC, 8, 2)
      objFILE.WriteLine (strLBL & strVAL)
      objHTML.LabelValue strLBL, strVAL
      
      strLBL = "         Critical Gas: "
      strVAL = objUtil.Nbr2Str(objRock.SGCrit, 8, 2)
      objFILE.WriteLine (strLBL & strVAL)
      objHTML.LabelValue strLBL, strVAL
    End If
    objFILE.WriteBlankLines (2)
    
    strLBL = "Correlation Type: "
    strVAL = "Corey"
    If objRock.CORR = 1 Then strVAL = "Honarpour"
    objFILE.WriteLine (strLBL & strVAL)
    objHTML.LabelValue strLBL, strVAL

    If objRock.CORR = 0 Then
      strLBL = "  K Exponent: "
      strVAL = objUtil.Nbr2Str(objRock.CoreyK, 5, 2)
      objFILE.WriteLine (strLBL & strVAL)
      objHTML.LabelValue strLBL, strVAL
      
      strLBL = "  N Exponent: "
      strVAL = objUtil.Nbr2Str(objRock.CoreyN, 5, 2)
      objFILE.WriteLine (strLBL & strVAL)
      objHTML.LabelValue strLBL, strVAL
    Else
      strLBL = "  Porosity (frac): "
      strVAL = objUtil.Nbr2Str(objRock.HRPoro, 6, 2)
      objFILE.WriteLine (strLBL & strVAL)
      objHTML.LabelValue strLBL, strVAL
      
      strLBL = "    Air Perm (md): "
      strVAL = objUtil.Nbr2Str(objRock.HRAir, 6, 2)
      objFILE.WriteLine (strLBL & strVAL)
      objHTML.LabelValue strLBL, strVAL
      
      strLBL = "        Krg @Sorg: "
      strVAL = objUtil.Nbr2Str(objRock.HRKrg, 6, 2)
      objFILE.WriteLine (strLBL & strVAL)
      objHTML.LabelValue strLBL, strVAL
    End If

    If objRock.Fluids = 0 Then                           'Oil/Water system
      objFILE.WriteBlankLines (2)
      objFILE.WriteLine ("            Saturations   Relative Permeability")
      objFILE.WriteLine ("      Water         Oil       Water         Oil")
      objFILE.WriteLine (" ----------  ----------  ----------  ----------")


      ColData(1) = "Water (Sat)"
      ColData(2) = "Oil (Sat)"
      ColData(3) = "Water (Rel Perm)"
      ColData(4) = "Oil (Rel Perm"
      objHTML.startTABLE 4, ColData

      For ii = 1 To objRock.NWet
        ColData(1) = objUtil.Nbr2Str(objRock.GetSWet(ii), 11, 2)
        objFILE.Write (ColData(1))

        ColData(2) = objUtil.Nbr2Str(objRock.GetSNWet(ii), 12, 2)
        objFILE.Write (ColData(2))
  
        ColData(3) = objUtil.Nbr2Str(objRock.GetKRWat(ii), 12, 4)
        objFILE.Write (ColData(3))

        ColData(4) = objUtil.Nbr2Str(objRock.GetKROil(ii), 12, 4)
        objFILE.WriteLine (ColData(4))

        objHTML.dataTABLE 4, ColData
      Next ii
      objHTML.endTABLE
    End If

    If objRock.Fluids = 1 Then                           'Gas/Oil system
      objFILE.WriteBlankLines (2)
      objFILE.WriteLine ("            Saturations               Relative Permeability")
      objFILE.WriteLine ("        Gas        Soil      Swater         Gas         Oil")
      objFILE.WriteLine (" ----------  ----------  ----------  ----------  ----------")


      ColData(1) = "Gas (Sat)"
      ColData(2) = "Soil (Sat)"
      ColData(3) = "Swater (Sat)"
      ColData(4) = "Gas (Rel Perm)"
      ColData(5) = "Oil (Rel Perm)"
      objHTML.startTABLE 5, ColData

      For ii = 1 To objRock.NWet
        ColData(1) = objUtil.Nbr2Str(objRock.GetSNWet(ii), 11, 4)
        objFILE.Write (ColData(1))

        ColData(2) = objUtil.Nbr2Str(objRock.GetSWet(ii) - objRock.SWC, 12, 2)
        objFILE.Write (ColData(2))
  
        ColData(3) = objUtil.Nbr2Str(objRock.SWC, 12, 2)
        objFILE.Write (ColData(3))

        ColData(4) = objUtil.Nbr2Str(objRock.GetKRGas(ii), 12, 4)
        objFILE.Write (ColData(4))

        ColData(5) = objUtil.Nbr2Str(objRock.GetKROil(ii), 12, 4)
        objFILE.WriteLine (ColData(5))

        objHTML.dataTABLE 5, ColData
      Next ii
      objHTML.endTABLE
    End If
  End If
  
  objFILE.Close
  Set objFILE = Nothing
  Set objHTML = Nothing
  
  Call InfoMSG("Report output complete!", "File: " & FileName)
End Sub
